/* $ANTLR 2.7.3rc2: "calc.g" -> "CalcWalker.cpp"$ */
#line 11 "calc.g"

#include "CException.h"
#include "MyASTNode.h" // $FAB
#include "CMobile.h"
#include "CWorld.h"
#include "messages_calc.h"

extern int cur_line;
extern int cur_mob;
#define getCurLine() (cur_line+1) 
#define warning(msg) display_warning(msg,m_Mobile_id+1,getCurLine())
    
#define ME            	        -1
#define MOUSE          		-2
#define COLLIDER       		-3
#define PREV           		-4
#define NEXT       	    	-5
#define NEAREST        		-6
#define NEAREST2       		-7
#define NEAREST3       		-8
#define NEAREST_LEFT   		-9
#define NEAREST_RIGHT 	       -10
#define NEAREST_UP    	       -11
#define NEAREST_DOWN  	       -12
#define EMPTY         	       -13
#define NEAREST_INDIR 	       -14
#define NEAREST_INDIR2 	       -15
#define NEAREST_INDIR3	       -16
#define CAMERA                 -17
#define LIGHT1                 -18
#define LIGHT2                 -19
#define LIGHT3                 -20

// flags pour get*Ptr()
#define MOVEABLE               0x01
#define NOT_PSEUDOMOBILES      0x02
#define NOT_ME                 0x04
#define NOT_ME_IF_START      ( (field==FIELD_START)?NOT_ME:0 )

// flags pour get*Ref()
#define CREATE_ON_FAIL 0x01
#define MUST_EXIST     0x02

// macros utiles
#define is_local(ib) ( ((ib) == -1) || ((ib)-1 == m_Mobile_client_id) )

#define is_me(ia,ib) ( is_local(ib) &&      \
          ( ( (ia) == -1) || ( (ia)-1 == m_Mobile_id ) )    )

#define conv_ref_to_number(mob) (                       \
   ( is_local((mob).client) && ((mob).mobile>-1) )      \
        ? (mob).mobile                                  \
        : WORLD.getMobileLocalId(getMobilePtr(mob))  )


#define RED     "4278190080" // 0xff000000
#define GREEN     "16711680" // 0x00ff0000
#define BLUE         "65280" // 0x0000ff00
#define YELLOW  "4294901760" // 0xffff0000
#define CYAN      "16776960" // 0x00ffff00
#define PURPLE  "4278255360" // 0xff00ff00
#define WHITE   "4294967040" // 0xffffff00
#define BLACK            "0" // 0x00000000
#define GRAY    "2155905024" // 0x80808000
#define ORANGE  "4287102976" // 0xff880000

#line 70 "CalcWalker.cpp"
#include "CalcWalker.hpp"
#include <antlr/Token.hpp>
#include <antlr/AST.hpp>
#include <antlr/NoViableAltException.hpp>
#include <antlr/MismatchedTokenException.hpp>
#include <antlr/SemanticException.hpp>
#include <antlr/BitSet.hpp>
#line 88 "calc.g"

// --------------- routines utilitaires ---------------------

// --- pour "attrb ref : value"   (lvalue)
// identification (ds nfo) de l'attrb du mobile ref = (i,j)
void CalcWalker::set_atr_nfo(atr_nfo &nfo, int i, int j, string nom, int var)
{
CMobile *m=NULL;

int ia = i; // mob.mobile;
int ib = j; // mob.client;
bool pseudo = false;
	
if( ia < 0 )
{
switch(ia)
{
	    case ME:              // moi
	        m = m_Mobile; break;
case CAMERA :         // camera
m = WORLD.getCamera(); pseudo = true; break;
case LIGHT1 :         // lampe 1
m = WORLD.getLight1(); pseudo = true; break;
case LIGHT2 :         // lampe 2
m = WORLD.getLight2(); pseudo = true; break;
case LIGHT3 :         // lampe 3
m = WORLD.getLight3(); pseudo = true; break;
case PREV :          // get previous mobile
m=WORLD.getPrevMobile(m_Mobile);  break;
case NEXT :          // get next mobile
m=WORLD.getNextMobile(m_Mobile);  break;
	    case EMPTY:          // vide
	        m = NULL; break;
default: break;
}
} 
else if (ib > -1)
{   // mobile on distant client
throw CException(MSG_modif_another);
}
else
{ // mobile on local client
	  if ( ia == 0 )
	    {
	      m=NULL;
	      warning(MSG_null_ref);
	    }
	  else if (ia > -1)
	      m=WORLD.getLocalMobile(ia-1);
}

	nfo.m = m;
	nfo.pseudo = pseudo;
nfo.name = nom;
nfo.variable = var;
}

// --- affectation des attributs (lvalue)
void CalcWalker::setAttributes(atr_nfo& atr, double a)
{
if (atr.name == "x") {
	atr.m->pos().setX(a);
}
else if (atr.name == "y") {
	atr.m->pos().setY(a);
}
else if (atr.name == "dx") {
	atr.m->speed().setX(a);
}
else if (atr.name == "dy") {
	atr.m->speed().setY(a);
}
else if (atr.name == "angle") {
	atr.m->setAngle(a);
}
else if (atr.name == "icon") {
	atr.m->setIcon((int) a);
}
else if (atr.name == "mem") {
	atr.m->setVar(atr.variable, a);
}
else if (atr.name == "color") {
	atr.m->setColor((unsigned int)a);
}
else if (atr.name == "red") {
	unsigned int c;
	c = (unsigned int)( (a<=0)?0: (a>=1.)? 255.: 255.*a);
	atr.m->setColor( (atr.m->getColor() & 0x00ffff00) | ( c << 24 ) );
}
else if (atr.name == "green") {
	unsigned int c;
	c = (unsigned int)( (a<=0)?0: (a>=1.)? 255.: 255.*a);
	atr.m->setColor( (atr.m->getColor() & 0xff00ff00) | ( c << 16 ) );
}
else if (atr.name == "blue") {
	unsigned int c;
	c = (unsigned int)( (a<=0)?0: (a>=1.)? 255.: 255.*a);
	atr.m->setColor( (atr.m->getColor() & 0xffff0000) | ( c <<  8 ) );
}
else if (atr.name == "gray") {
	unsigned int c;
	c = (unsigned int)( (a<=0)?0: (a>=1.)? 255.: 255.*a);
	atr.m->setColor( (atr.m->getColor() & 0x00ffff00) | ( c << 24 ) );
	atr.m->setColor( (atr.m->getColor() & 0xff00ff00) | ( c << 16 ) );
	atr.m->setColor( (atr.m->getColor() & 0xffff0000) | ( c <<  8 ) );
}
else if (atr.name == "width") {
	atr.m->setWidth(a);
}
else if (atr.name == "height") {
	atr.m->setHeight(a);
}
else if (atr.name == "zoom") {
	atr.m->setWidth(a);
	atr.m->setHeight(a);
}
else if (atr.name == "visible") {
	atr.m->setVisible(a != 0.0);
	if (!atr.pseudo) atr.m->updateVisible();
}
else if (atr.name == "contact") {
	// nothing to do.
}
else
	throw CException(MSG_undef_attrb);
}

// --- retourne un pointeur sur un mobile (i, i@j, ou special)
CMobile *CalcWalker::getMobilePtr(mob_adress mob, int mode)
{
CMobile *m=NULL;

int ia = mob.mobile;
int ib = mob.client;

if( ia == -100)
return NULL;

if( ia < 0 )
{
	  switch(ia)
{
	   case ME:              // moi
	        if (mode&NOT_ME) throw CException(MSG_notme);
	        m = m_Mobile;          break;
case MOUSE :          // mouse
	        if (mode&NOT_PSEUDOMOBILES) throw CException(MSG_notmouse);
	        if (mode&MOVEABLE)   throw CException(MSG_notmouse);
	        //if (mode&MOVEABLE)  { cerr<<cur_line; throw MyException(MSG_tst_notmouse);}
m = WORLD.getMouse();  break;
case CAMERA :         // camera
	        if (mode&NOT_PSEUDOMOBILES) throw CException(MSG_notcamera);
m = WORLD.getCamera(); break;
case LIGHT1 :         // lampe 1
	        if (mode&NOT_PSEUDOMOBILES) throw CException(MSG_notlight);
m = WORLD.getLight1(); break;
case LIGHT2 :         // lampe 2
	        if (mode&NOT_PSEUDOMOBILES) throw CException(MSG_notlight);
m = WORLD.getLight2(); break;
case LIGHT3 :         // lampe 3
	        if (mode&NOT_PSEUDOMOBILES) throw CException(MSG_notlight);
m = WORLD.getLight3(); break;
case COLLIDER :      // collider
m = m_Collider;        break;
case PREV :          // get previous mobile
m=WORLD.getPrevMobile(m_Mobile);  break;
case NEXT :          // get next mobile
m=WORLD.getNextMobile(m_Mobile);  break;
case NEAREST :       // plusproche
m = WORLD.getNearest(m_Mobile);   break;
case NEAREST2 :      // plusproche
m = WORLD.getNearest(m_Mobile,2); break;
case NEAREST3 :      // plusproche
m = WORLD.getNearest(m_Mobile,3); break;
case NEAREST_LEFT :  // plusproche_gauche
m = WORLD.getNearestDir(m_Mobile,-1,0,M_PI/2); break;
case NEAREST_RIGHT : // plusproche_droit
m = WORLD.getNearestDir(m_Mobile,1,0,M_PI/2);  break;
case NEAREST_UP :    // plusproche_haut
m = WORLD.getNearestDir(m_Mobile,0,1,M_PI/2);  break;
case NEAREST_DOWN :  // plusproche_bas
m = WORLD.getNearestDir(m_Mobile,0,-1,M_PI/2); break;
	    case EMPTY:          // NULL
	        m = NULL;            break;
	    case NEAREST_INDIR:
		m = WORLD.getNearestDir(m_Mobile, mob.dx, mob.dy, mob.angle);
		break;
	    case NEAREST_INDIR2:
		m = WORLD.getNearestDir(m_Mobile, mob.dx, mob.dy, mob.angle, 2);
		break;
	    case NEAREST_INDIR3:
		m = WORLD.getNearestDir(m_Mobile, mob.dx, mob.dy, mob.angle, 3);
		break;
default: break;
}
} 
else if (ib > -1)
{   // mobile on distant client
if (ia == -1) throw CException(MSG_mobile_id);
	    if ((mode&NOT_ME) && is_me(ia,ib)) throw CException(MSG_notme);
m = WORLD.getDistantMobile(ia-1,ib-1);
}
else
{   // mobile on local client
	    if (ia == 0)
	        m = NULL;
	    else if (ia > -1)
{
	        if ((mode&NOT_ME) && is_me(ia,-1))
		  throw CException(MSG_notme);
m = WORLD.getLocalMobile(ia-1);
}
}

return m;
}

// --- teste si deux ref sont egales.
// NB: comme les INT sont pris pour des refs, cette fonction
// permet au passage de traiter correctement leur comparaison.
bool CalcWalker::areMobilesEqual(mob_adress mob, mob_adress mob2)
{
// std::cerr << "[DEBUG] in are_M_equal\n";
if (  (mob.mobile>=0) && is_local(mob.client)   &&
(mob2.mobile>=0) && is_local(mob2.client) )
	return (mob.mobile == mob2.mobile);
else
	return (getMobilePtr(mob) == getMobilePtr(mob2));
}

// --- teste ref=fexp (cast)
bool CalcWalker::isMobileEqualN(mob_adress mob, double f)
{ int i = (int)f;
	// std::cerr << "[DEBUG] in is_M_eql_N" << f << i << (f==i) <<"\n";
	if (f!=i) return false;  // f n'est pas un int. (compare int et double !)
	if ( ( mob.mobile>=0) && is_local(mob.client) )
	  return (mob.mobile == i);
	else {
	  mob_adress mob2;
	  mob2.mobile=i; mob2.client=-1;
	  return (getMobilePtr(mob)==getMobilePtr(mob2));
	  // return (getMobilePtr(mob)==WORLD.getLocalMobile(i-1));
	}
}

// --- retourne la valeur de l'attribut attrib du mobile mob (rvalue)
double CalcWalker::get_atr_nfo(int attrib, mob_adress mob, int var)
{
double r;
CMobile *m= getMobilePtr(mob);
// give its value to the attribute
r = 0.0;
	if (!m) warning(MSG_null_ref);
else 
{
	  switch( attrib )
{
case ATTR_X:  r=m->pos().x();   break;
case ATTR_Y:  r=m->pos().y();   break;
case ATTR_DX: r=m->speed().x(); break;
case ATTR_DY: r=m->speed().y(); break;
case ATTR_ANGLE:   r=m->getAngle();  break;
case ATTR_ICONE:   r=m->getIcon();   break;
case ATTR_VAR:     r=m->getVar(var); break;
case ATTR_COULEUR: r=m->getColor();  break;
case ATTR_ROUGE: r= ( ( m->getColor() & 0xff000000 ) >> 24 )/255.; break;
case ATTR_VERT:  r= ( ( m->getColor() & 0x00ff0000 ) >> 16 )/255.; break;
case ATTR_BLEU:  r= ( ( m->getColor() & 0x0000ff00 ) >>  8 )/255.; break;
case ATTR_GRIS:  {
				r  =  ( ( m->getColor() & 0x0000ff00 ) >>  8);
				r +=  ( ( m->getColor() & 0x00ff0000 ) >> 16);
				r +=  ( ( m->getColor() & 0xff000000 ) >> 24);
				r /= (3.0*255.);
				break;
			     }
case ATTR_LARGEUR: r=m->getWidth();  break;
case ATTR_HAUTEUR: r=m->getHeight(); break;
case ATTR_CHOCX:   r=m_Choc.x();     break;
case ATTR_CHOCY:   r=m_Choc.y();     break;
case ATTR_VISIBLE: r= ( m->isVisible()    ? 1.0 : 0.0 ); break;
case ATTR_CONTACT: r= ( m->firstContact() ? 1.0 : 0.0 ); break;

default: r = 0.0; break;
}
}
return r;
}

// retourne un pointeur sur une variable temporaire float
double *CalcWalker::getFloatRef(string s, int mode)
{
fltMap_t::iterator it = mFloats.find(s);
if( it != mFloats.end() )
{
return &((*it).second);
}
else if( mode & CREATE_ON_FAIL )
{
mFloats[s]= 0.0;
return &(mFloats[s]);
}
else {
	    if (mode & MUST_EXIST ) throw CException(MSG_undef_f);
return NULL;
	}
}

// retourne un pointeur sur une variable temporaire ref
mob_adress *CalcWalker::getMobileRef(string s, int mode)
{
mobMap_t::iterator it = mMobiles.find(s);
if( it != mMobiles.end() )
{
return &((*it).second);
}
else if( mode & CREATE_ON_FAIL )
{
mob_adress a;
a.mobile = -1; a.client = -1;
mMobiles[s]=a;
return  &(mMobiles[s]);
}
else {
	    if (mode & MUST_EXIST) throw CException(MSG_undef_r);
return NULL;
	}
}

// versions secure pour l'ecriture des variables:
// detruisent d'abord la variable si elle existe dans l'autre type
double *CalcWalker::getFloatWriteRefCheck(string s, int mode) {
if (getMobileRef(s)) {
	mMobiles.erase(s);
	// cerr << "[DEBUG] remove rvar\n";
}
return getFloatRef(s, mode);
}
mob_adress *CalcWalker::getMobileWriteRefCheck(string s, int mode) {
if (getFloatRef(s)) {
	mFloats.erase(s);
	// cerr << "[DEBUG] remove fvar\n";
}
return getMobileRef(s, mode);
}


#line 425 "CalcWalker.cpp"
CalcWalker::CalcWalker()
	: ANTLR_USE_NAMESPACE(antlr)TreeParser() {
}

void CalcWalker::start(ANTLR_USE_NAMESPACE(antlr)RefAST _t) {
	ANTLR_USE_NAMESPACE(antlr)RefAST start_AST_in = _t;
	
	try {      // for error handling
		{ // ( ... )*
		for (;;) {
			if (_t == ANTLR_USE_NAMESPACE(antlr)nullAST )
				_t = ASTNULL;
			if ((_tokenSet_0.member(_t->getType()))) {
				expr_(_t);
				_t = _retTree;
			}
			else {
				goto _loop3;
			}
			
		}
		_loop3:;
		} // ( ... )*
	}
	catch (ANTLR_USE_NAMESPACE(antlr)RecognitionException& ex) {
		if( inputState->guessing == 0 ) {
			reportError(ex);
			if ( _t != ANTLR_USE_NAMESPACE(antlr)nullAST )
				_t = _t->getNextSibling();
		} else {
			throw;
		}
	}
	_retTree = _t;
}

void CalcWalker::expr_(ANTLR_USE_NAMESPACE(antlr)RefAST _t) {
	ANTLR_USE_NAMESPACE(antlr)RefAST expr__AST_in = _t;
	ANTLR_USE_NAMESPACE(antlr)RefAST e = ANTLR_USE_NAMESPACE(antlr)nullAST;
#line 495 "calc.g"
#line 466 "CalcWalker.cpp"
	
	try {      // for error handling
		{
		e = (_t == ASTNULL) ? ANTLR_USE_NAMESPACE(antlr)nullAST : _t;
		expr(_t);
		_t = _retTree;
		}
		if ( inputState->guessing==0 ) {
#line 498 "calc.g"
			
			MyASTNode *q = static_cast<MyASTNode*>((ANTLR_USE_NAMESPACE(antlr)AST*)e);
			cur_line = q->getLine();
			
#line 480 "CalcWalker.cpp"
		}
	}
	catch (ANTLR_USE_NAMESPACE(antlr)RecognitionException& ex) {
		if( inputState->guessing == 0 ) {
			reportError(ex);
			if ( _t != ANTLR_USE_NAMESPACE(antlr)nullAST )
				_t = _t->getNextSibling();
		} else {
			throw;
		}
	}
	_retTree = _t;
}

void CalcWalker::expr(ANTLR_USE_NAMESPACE(antlr)RefAST _t) {
	ANTLR_USE_NAMESPACE(antlr)RefAST expr_AST_in = _t;
	ANTLR_USE_NAMESPACE(antlr)RefAST F = ANTLR_USE_NAMESPACE(antlr)nullAST;
	ANTLR_USE_NAMESPACE(antlr)RefAST id3 = ANTLR_USE_NAMESPACE(antlr)nullAST;
	ANTLR_USE_NAMESPACE(antlr)RefAST id_1 = ANTLR_USE_NAMESPACE(antlr)nullAST;
	ANTLR_USE_NAMESPACE(antlr)RefAST id_2 = ANTLR_USE_NAMESPACE(antlr)nullAST;
	ANTLR_USE_NAMESPACE(antlr)RefAST id2 = ANTLR_USE_NAMESPACE(antlr)nullAST;
	ANTLR_USE_NAMESPACE(antlr)RefAST id = ANTLR_USE_NAMESPACE(antlr)nullAST;
	ANTLR_USE_NAMESPACE(antlr)RefAST id_3 = ANTLR_USE_NAMESPACE(antlr)nullAST;
#line 506 "calc.g"
	
	double    a, b, cond;
	atr_nfo  atr;
	mob_adress mob;
	
#line 510 "CalcWalker.cpp"
	
	try {      // for error handling
		if (_t == ANTLR_USE_NAMESPACE(antlr)nullAST )
			_t = ASTNULL;
		switch ( _t->getType()) {
		case LITERAL_if:
		{
			ANTLR_USE_NAMESPACE(antlr)RefAST __t7 = _t;
			ANTLR_USE_NAMESPACE(antlr)RefAST tmp1_AST_in = _t;
			match(_t,LITERAL_if);
			_t = _t->getFirstChild();
			F = (_t == ASTNULL) ? ANTLR_USE_NAMESPACE(antlr)nullAST : _t;
			cond=fexpr(_t);
			_t = _retTree;
			_t = __t7;
			_t = _t->getNextSibling();
			if ( inputState->guessing==0 ) {
#line 513 "calc.g"
				
				if( cond != 0.0 )
					    {
				if( F->getNextSibling() )
						    if( F->getNextSibling()->getFirstChild() )
							start(F->getNextSibling()->getFirstChild());
					    }
					    else
					    {
				if( F->getNextSibling() )
						{
						    if( F->getNextSibling()->getNextSibling() )
						    {
							start( F->getNextSibling()->getNextSibling() );
						    }
						}
					    }
				
#line 547 "CalcWalker.cpp"
			}
			break;
		}
		case LITERAL_stop:
		{
			ANTLR_USE_NAMESPACE(antlr)RefAST __t8 = _t;
			ANTLR_USE_NAMESPACE(antlr)RefAST tmp2_AST_in = _t;
			match(_t,LITERAL_stop);
			_t = _t->getFirstChild();
			mob=ref(_t);
			_t = _retTree;
			_t = __t8;
			_t = _t->getNextSibling();
			if ( inputState->guessing==0 ) {
#line 532 "calc.g"
				
				CMobile * mref =
					      getMobilePtr(mob, NOT_PSEUDOMOBILES|NOT_ME_IF_START);
					    if (!mref)
					      warning(MSG_null_ref);
					    else
					      mref->execStop();
				
#line 571 "CalcWalker.cpp"
			}
			break;
		}
		case LITERAL_start:
		{
			ANTLR_USE_NAMESPACE(antlr)RefAST __t9 = _t;
			ANTLR_USE_NAMESPACE(antlr)RefAST tmp3_AST_in = _t;
			match(_t,LITERAL_start);
			_t = _t->getFirstChild();
			mob=ref(_t);
			_t = _retTree;
			_t = __t9;
			_t = _t->getNextSibling();
			if ( inputState->guessing==0 ) {
#line 541 "calc.g"
				
				CMobile * mref =
					      getMobilePtr(mob, NOT_PSEUDOMOBILES|NOT_ME_IF_START);
					    if (!mref)
					      warning(MSG_null_ref);
					    else
					      mref->execStart();
				
#line 595 "CalcWalker.cpp"
			}
			break;
		}
		case LITERAL_restart:
		{
			ANTLR_USE_NAMESPACE(antlr)RefAST __t10 = _t;
			ANTLR_USE_NAMESPACE(antlr)RefAST tmp4_AST_in = _t;
			match(_t,LITERAL_restart);
			_t = _t->getFirstChild();
			mob=ref(_t);
			_t = _retTree;
			_t = __t10;
			_t = _t->getNextSibling();
			if ( inputState->guessing==0 ) {
#line 550 "calc.g"
				
				CMobile * mref =
					      getMobilePtr(mob, NOT_PSEUDOMOBILES|NOT_ME_IF_START);
					    if (!mref)
					      warning(MSG_null_ref);
					    else 
				mref->execRestart();
				
#line 619 "CalcWalker.cpp"
			}
			break;
		}
		case LITERAL_like:
		{
			ANTLR_USE_NAMESPACE(antlr)RefAST __t11 = _t;
			ANTLR_USE_NAMESPACE(antlr)RefAST tmp5_AST_in = _t;
			match(_t,LITERAL_like);
			_t = _t->getFirstChild();
			mob=ref(_t);
			_t = _retTree;
			_t = __t11;
			_t = _t->getNextSibling();
			if ( inputState->guessing==0 ) {
#line 559 "calc.g"
				
				CMobile * mref =
					      getMobilePtr(mob, NOT_PSEUDOMOBILES | NOT_ME);
					    if (!mref)
					      warning(MSG_null_ref);
					    else 
					      mref->startParserForField(this, field);
				
#line 643 "CalcWalker.cpp"
			}
			break;
		}
		case LITERAL_move_to:
		{
			ANTLR_USE_NAMESPACE(antlr)RefAST __t12 = _t;
			ANTLR_USE_NAMESPACE(antlr)RefAST tmp6_AST_in = _t;
			match(_t,LITERAL_move_to);
			_t = _t->getFirstChild();
			mob=ref(_t);
			_t = _retTree;
			a=fexpr(_t);
			_t = _retTree;
			b=fexpr(_t);
			_t = _retTree;
			_t = __t12;
			_t = _t->getNextSibling();
			if ( inputState->guessing==0 ) {
#line 568 "calc.g"
				
				CMobile * mref = NULL;
				mref = getMobilePtr(mob,MOVEABLE);
					    if (!mref) warning(MSG_null_ref);
					    else mref->execMoveTo(a, b);
				
#line 669 "CalcWalker.cpp"
			}
			break;
		}
		case LITERAL_echo:
		{
			ANTLR_USE_NAMESPACE(antlr)RefAST __t16 = _t;
			ANTLR_USE_NAMESPACE(antlr)RefAST tmp7_AST_in = _t;
			match(_t,LITERAL_echo);
			_t = _t->getFirstChild();
			id3 = _t;
			match(_t,ID);
			_t = _t->getNextSibling();
			_t = __t16;
			_t = _t->getNextSibling();
			if ( inputState->guessing==0 ) {
#line 575 "calc.g"
				cerr << id3->getText() <<"\n";
#line 687 "CalcWalker.cpp"
			}
			break;
		}
		default:
			bool synPredMatched19 = false;
			if (((_t->getType() == COLON))) {
				ANTLR_USE_NAMESPACE(antlr)RefAST __t19 = _t;
				synPredMatched19 = true;
				inputState->guessing++;
				try {
					{
					ANTLR_USE_NAMESPACE(antlr)RefAST __t18 = _t;
					ANTLR_USE_NAMESPACE(antlr)RefAST tmp8_AST_in = _t;
					match(_t,COLON);
					_t = _t->getFirstChild();
					ANTLR_USE_NAMESPACE(antlr)RefAST tmp9_AST_in = _t;
					match(_t,LITERAL_trace);
					_t = _t->getNextSibling();
					fexpr(_t);
					_t = _retTree;
					_t = __t18;
					_t = _t->getNextSibling();
					}
				}
				catch (ANTLR_USE_NAMESPACE(antlr)RecognitionException& pe) {
					synPredMatched19 = false;
				}
				_t = __t19;
				inputState->guessing--;
			}
			if ( synPredMatched19 ) {
				ANTLR_USE_NAMESPACE(antlr)RefAST __t20 = _t;
				ANTLR_USE_NAMESPACE(antlr)RefAST tmp10_AST_in = _t;
				match(_t,COLON);
				_t = _t->getFirstChild();
				ANTLR_USE_NAMESPACE(antlr)RefAST tmp11_AST_in = _t;
				match(_t,LITERAL_trace);
				_t = _t->getNextSibling();
				a=fexpr(_t);
				_t = _retTree;
				_t = __t20;
				_t = _t->getNextSibling();
				if ( inputState->guessing==0 ) {
#line 580 "calc.g"
					
						  WORLD.getCamera()->setVisible(a);
						
#line 735 "CalcWalker.cpp"
				}
			}
			else {
				bool synPredMatched23 = false;
				if (((_t->getType() == COLON))) {
					ANTLR_USE_NAMESPACE(antlr)RefAST __t23 = _t;
					synPredMatched23 = true;
					inputState->guessing++;
					try {
						{
						ANTLR_USE_NAMESPACE(antlr)RefAST __t22 = _t;
						ANTLR_USE_NAMESPACE(antlr)RefAST tmp12_AST_in = _t;
						match(_t,COLON);
						_t = _t->getFirstChild();
						ANTLR_USE_NAMESPACE(antlr)RefAST tmp13_AST_in = _t;
						match(_t,ID);
						_t = _t->getNextSibling();
						ANTLR_USE_NAMESPACE(antlr)RefAST tmp14_AST_in = _t;
						match(_t,ID);
						_t = _t->getNextSibling();
						_t = __t22;
						_t = _t->getNextSibling();
						}
					}
					catch (ANTLR_USE_NAMESPACE(antlr)RecognitionException& pe) {
						synPredMatched23 = false;
					}
					_t = __t23;
					inputState->guessing--;
				}
				if ( synPredMatched23 ) {
					ANTLR_USE_NAMESPACE(antlr)RefAST __t24 = _t;
					ANTLR_USE_NAMESPACE(antlr)RefAST tmp15_AST_in = _t;
					match(_t,COLON);
					_t = _t->getFirstChild();
					id_1 = _t;
					match(_t,ID);
					_t = _t->getNextSibling();
					id_2 = _t;
					match(_t,ID);
					_t = _t->getNextSibling();
					_t = __t24;
					_t = _t->getNextSibling();
					if ( inputState->guessing==0 ) {
#line 590 "calc.g"
						
							 double *fref1,*fref2;
							 mob_adress *mref1, *mref2;
							 fref2 = getFloatRef(id_2->getText());
							 if (fref2) {
							   fref1 = getFloatWriteRefCheck(id_1->getText(), CREATE_ON_FAIL);
							   if(fref1) *fref1 = *fref2;
							 }
							 else {
							   mref2 = getMobileRef(id_2->getText(), MUST_EXIST);
							   mref1 = getMobileWriteRefCheck(id_1->getText(), CREATE_ON_FAIL);
						if(mref1) *mref1 = *mref2;
						}
						
#line 795 "CalcWalker.cpp"
					}
				}
				else {
					bool synPredMatched27 = false;
					if (((_t->getType() == COLON))) {
						ANTLR_USE_NAMESPACE(antlr)RefAST __t27 = _t;
						synPredMatched27 = true;
						inputState->guessing++;
						try {
							{
							ANTLR_USE_NAMESPACE(antlr)RefAST __t26 = _t;
							ANTLR_USE_NAMESPACE(antlr)RefAST tmp16_AST_in = _t;
							match(_t,COLON);
							_t = _t->getFirstChild();
							ANTLR_USE_NAMESPACE(antlr)RefAST tmp17_AST_in = _t;
							match(_t,ID);
							_t = _t->getNextSibling();
							fexpr(_t);
							_t = _retTree;
							_t = __t26;
							_t = _t->getNextSibling();
							}
						}
						catch (ANTLR_USE_NAMESPACE(antlr)RecognitionException& pe) {
							synPredMatched27 = false;
						}
						_t = __t27;
						inputState->guessing--;
					}
					if ( synPredMatched27 ) {
						ANTLR_USE_NAMESPACE(antlr)RefAST __t28 = _t;
						ANTLR_USE_NAMESPACE(antlr)RefAST tmp18_AST_in = _t;
						match(_t,COLON);
						_t = _t->getFirstChild();
						id2 = _t;
						match(_t,ID);
						_t = _t->getNextSibling();
						a=fexpr(_t);
						_t = _retTree;
						_t = __t28;
						_t = _t->getNextSibling();
						if ( inputState->guessing==0 ) {
#line 605 "calc.g"
							
							double * fref = NULL;
							fref = getFloatWriteRefCheck(id2->getText(), CREATE_ON_FAIL);
							if(fref) *fref = a;
							
#line 844 "CalcWalker.cpp"
						}
					}
					else {
						bool synPredMatched31 = false;
						if (((_t->getType() == COLON))) {
							ANTLR_USE_NAMESPACE(antlr)RefAST __t31 = _t;
							synPredMatched31 = true;
							inputState->guessing++;
							try {
								{
								ANTLR_USE_NAMESPACE(antlr)RefAST __t30 = _t;
								ANTLR_USE_NAMESPACE(antlr)RefAST tmp19_AST_in = _t;
								match(_t,COLON);
								_t = _t->getFirstChild();
								ANTLR_USE_NAMESPACE(antlr)RefAST tmp20_AST_in = _t;
								match(_t,ID);
								_t = _t->getNextSibling();
								ref(_t);
								_t = _retTree;
								_t = __t30;
								_t = _t->getNextSibling();
								}
							}
							catch (ANTLR_USE_NAMESPACE(antlr)RecognitionException& pe) {
								synPredMatched31 = false;
							}
							_t = __t31;
							inputState->guessing--;
						}
						if ( synPredMatched31 ) {
							ANTLR_USE_NAMESPACE(antlr)RefAST __t32 = _t;
							ANTLR_USE_NAMESPACE(antlr)RefAST tmp21_AST_in = _t;
							match(_t,COLON);
							_t = _t->getFirstChild();
							id = _t;
							match(_t,ID);
							_t = _t->getNextSibling();
							mob=ref(_t);
							_t = _retTree;
							_t = __t32;
							_t = _t->getNextSibling();
							if ( inputState->guessing==0 ) {
#line 611 "calc.g"
								
								mob_adress * mref = NULL;
								mref = getMobileWriteRefCheck(id->getText(), CREATE_ON_FAIL);
								if(mref) *mref = mob;
								
#line 893 "CalcWalker.cpp"
							}
						}
						else {
							bool synPredMatched35 = false;
							if (((_t->getType() == COLON))) {
								ANTLR_USE_NAMESPACE(antlr)RefAST __t35 = _t;
								synPredMatched35 = true;
								inputState->guessing++;
								try {
									{
									ANTLR_USE_NAMESPACE(antlr)RefAST __t34 = _t;
									ANTLR_USE_NAMESPACE(antlr)RefAST tmp22_AST_in = _t;
									match(_t,COLON);
									_t = _t->getFirstChild();
									attribref(_t);
									_t = _retTree;
									ANTLR_USE_NAMESPACE(antlr)RefAST tmp23_AST_in = _t;
									match(_t,ID);
									_t = _t->getNextSibling();
									_t = __t34;
									_t = _t->getNextSibling();
									}
								}
								catch (ANTLR_USE_NAMESPACE(antlr)RecognitionException& pe) {
									synPredMatched35 = false;
								}
								_t = __t35;
								inputState->guessing--;
							}
							if ( synPredMatched35 ) {
								ANTLR_USE_NAMESPACE(antlr)RefAST __t36 = _t;
								ANTLR_USE_NAMESPACE(antlr)RefAST tmp24_AST_in = _t;
								match(_t,COLON);
								_t = _t->getFirstChild();
								atr=attribref(_t);
								_t = _retTree;
								id_3 = _t;
								match(_t,ID);
								_t = _t->getNextSibling();
								_t = __t36;
								_t = _t->getNextSibling();
								if ( inputState->guessing==0 ) {
#line 619 "calc.g"
									
										  double *fref = getFloatRef(id_3->getText());
										  if (fref)
										  setAttributes(atr, *fref);
										  else // cas "attrb:ref"
										  {
										    if (atr.name == "mem") {
										      mob_adress *mref = getMobileRef(id_3->getText(),MUST_EXIST);
										      // faute de savoir faire mem : ref, on traite au moins
										      // le cas ref=local (cast en int).
										      double a = conv_ref_to_number(*mref);
										      atr.m->setVar(atr.variable, a);
									
										    }
										    else throw CException(MSG_undef_f);
										  }
										
#line 954 "CalcWalker.cpp"
								}
							}
							else {
								bool synPredMatched39 = false;
								if (((_t->getType() == COLON))) {
									ANTLR_USE_NAMESPACE(antlr)RefAST __t39 = _t;
									synPredMatched39 = true;
									inputState->guessing++;
									try {
										{
										ANTLR_USE_NAMESPACE(antlr)RefAST __t38 = _t;
										ANTLR_USE_NAMESPACE(antlr)RefAST tmp25_AST_in = _t;
										match(_t,COLON);
										_t = _t->getFirstChild();
										attribref(_t);
										_t = _retTree;
										fexpr(_t);
										_t = _retTree;
										_t = __t38;
										_t = _t->getNextSibling();
										}
									}
									catch (ANTLR_USE_NAMESPACE(antlr)RecognitionException& pe) {
										synPredMatched39 = false;
									}
									_t = __t39;
									inputState->guessing--;
								}
								if ( synPredMatched39 ) {
									ANTLR_USE_NAMESPACE(antlr)RefAST __t40 = _t;
									ANTLR_USE_NAMESPACE(antlr)RefAST tmp26_AST_in = _t;
									match(_t,COLON);
									_t = _t->getFirstChild();
									atr=attribref(_t);
									_t = _retTree;
									a=fexpr(_t);
									_t = _retTree;
									_t = __t40;
									_t = _t->getNextSibling();
									if ( inputState->guessing==0 ) {
#line 637 "calc.g"
										
											  setAttributes(atr, a);
											
#line 999 "CalcWalker.cpp"
									}
								}
								else {
									bool synPredMatched43 = false;
									if (((_t->getType() == COLON))) {
										ANTLR_USE_NAMESPACE(antlr)RefAST __t43 = _t;
										synPredMatched43 = true;
										inputState->guessing++;
										try {
											{
											ANTLR_USE_NAMESPACE(antlr)RefAST __t42 = _t;
											ANTLR_USE_NAMESPACE(antlr)RefAST tmp27_AST_in = _t;
											match(_t,COLON);
											_t = _t->getFirstChild();
											attribref(_t);
											_t = _retTree;
											ref(_t);
											_t = _retTree;
											_t = __t42;
											_t = _t->getNextSibling();
											}
										}
										catch (ANTLR_USE_NAMESPACE(antlr)RecognitionException& pe) {
											synPredMatched43 = false;
										}
										_t = __t43;
										inputState->guessing--;
									}
									if ( synPredMatched43 ) {
										ANTLR_USE_NAMESPACE(antlr)RefAST __t44 = _t;
										ANTLR_USE_NAMESPACE(antlr)RefAST tmp28_AST_in = _t;
										match(_t,COLON);
										_t = _t->getFirstChild();
										atr=attribref(_t);
										_t = _retTree;
										mob=ref(_t);
										_t = _retTree;
										_t = __t44;
										_t = _t->getNextSibling();
										if ( inputState->guessing==0 ) {
#line 641 "calc.g"
											
												  if (atr.name == "mem") {
												    // cerr << "mem:ref \n";
												    double a = conv_ref_to_number(mob);
												    // faute de savoir faire mem : ref, on traite au moins
												    // le cas ref=local (cast en int).
												    atr.m->setVar(atr.variable, a);
												  }
												
#line 1050 "CalcWalker.cpp"
										}
									}
		else {
			throw ANTLR_USE_NAMESPACE(antlr)NoViableAltException(_t);
		}
		}}}}}}}
	}
	catch (ANTLR_USE_NAMESPACE(antlr)RecognitionException& ex) {
		if( inputState->guessing == 0 ) {
			reportError(ex);
			if ( _t != ANTLR_USE_NAMESPACE(antlr)nullAST )
				_t = _t->getNextSibling();
		} else {
			throw;
		}
	}
	_retTree = _t;
}

double  CalcWalker::fexpr(ANTLR_USE_NAMESPACE(antlr)RefAST _t) {
#line 715 "calc.g"
	double r;
#line 1073 "CalcWalker.cpp"
	ANTLR_USE_NAMESPACE(antlr)RefAST fexpr_AST_in = _t;
	ANTLR_USE_NAMESPACE(antlr)RefAST f = ANTLR_USE_NAMESPACE(antlr)nullAST;
	ANTLR_USE_NAMESPACE(antlr)RefAST i = ANTLR_USE_NAMESPACE(antlr)nullAST;
	ANTLR_USE_NAMESPACE(antlr)RefAST va = ANTLR_USE_NAMESPACE(antlr)nullAST;
	ANTLR_USE_NAMESPACE(antlr)RefAST id1 = ANTLR_USE_NAMESPACE(antlr)nullAST;
	ANTLR_USE_NAMESPACE(antlr)RefAST id2 = ANTLR_USE_NAMESPACE(antlr)nullAST;
	ANTLR_USE_NAMESPACE(antlr)RefAST id3 = ANTLR_USE_NAMESPACE(antlr)nullAST;
	ANTLR_USE_NAMESPACE(antlr)RefAST id4 = ANTLR_USE_NAMESPACE(antlr)nullAST;
	ANTLR_USE_NAMESPACE(antlr)RefAST id_1 = ANTLR_USE_NAMESPACE(antlr)nullAST;
	ANTLR_USE_NAMESPACE(antlr)RefAST id_2 = ANTLR_USE_NAMESPACE(antlr)nullAST;
	ANTLR_USE_NAMESPACE(antlr)RefAST id5 = ANTLR_USE_NAMESPACE(antlr)nullAST;
	ANTLR_USE_NAMESPACE(antlr)RefAST id6 = ANTLR_USE_NAMESPACE(antlr)nullAST;
	ANTLR_USE_NAMESPACE(antlr)RefAST id = ANTLR_USE_NAMESPACE(antlr)nullAST;
#line 715 "calc.g"
	
	double a, b;
	mob_adress mob, mob2;
	
#line 1092 "CalcWalker.cpp"
	
	try {      // for error handling
		if (_t == ANTLR_USE_NAMESPACE(antlr)nullAST )
			_t = ASTNULL;
		switch ( _t->getType()) {
		case STAR:
		{
			ANTLR_USE_NAMESPACE(antlr)RefAST __t78 = _t;
			ANTLR_USE_NAMESPACE(antlr)RefAST tmp29_AST_in = _t;
			match(_t,STAR);
			_t = _t->getFirstChild();
			a=fexpr(_t);
			_t = _retTree;
			b=fexpr(_t);
			_t = _retTree;
			_t = __t78;
			_t = _t->getNextSibling();
			if ( inputState->guessing==0 ) {
#line 725 "calc.g"
				r = a * b;
#line 1113 "CalcWalker.cpp"
			}
			break;
		}
		case DIV:
		{
			ANTLR_USE_NAMESPACE(antlr)RefAST __t79 = _t;
			ANTLR_USE_NAMESPACE(antlr)RefAST tmp30_AST_in = _t;
			match(_t,DIV);
			_t = _t->getFirstChild();
			a=fexpr(_t);
			_t = _retTree;
			b=fexpr(_t);
			_t = _retTree;
			_t = __t79;
			_t = _t->getNextSibling();
			if ( inputState->guessing==0 ) {
#line 726 "calc.g"
				
				if( b != 0.0 ) r = a / b;
					 else { r = 0; warning(MSG_div0); }
				
#line 1135 "CalcWalker.cpp"
			}
			break;
		}
		case FLOAT:
		{
			f = _t;
			match(_t,FLOAT);
			_t = _t->getNextSibling();
			if ( inputState->guessing==0 ) {
#line 730 "calc.g"
				r = atof(f->getText().c_str());
#line 1147 "CalcWalker.cpp"
			}
			break;
		}
		case INT:
		{
			i = _t;
			match(_t,INT);
			_t = _t->getNextSibling();
			if ( inputState->guessing==0 ) {
#line 731 "calc.g"
				r = atof(i->getText().c_str());
#line 1159 "CalcWalker.cpp"
			}
			break;
		}
		case LITERAL_sqr:
		{
			ANTLR_USE_NAMESPACE(antlr)RefAST __t80 = _t;
			ANTLR_USE_NAMESPACE(antlr)RefAST tmp31_AST_in = _t;
			match(_t,LITERAL_sqr);
			_t = _t->getFirstChild();
			a=fexpr(_t);
			_t = _retTree;
			_t = __t80;
			_t = _t->getNextSibling();
			if ( inputState->guessing==0 ) {
#line 732 "calc.g"
				r = a * a;
#line 1176 "CalcWalker.cpp"
			}
			break;
		}
		case LITERAL_sqrt:
		{
			ANTLR_USE_NAMESPACE(antlr)RefAST __t81 = _t;
			ANTLR_USE_NAMESPACE(antlr)RefAST tmp32_AST_in = _t;
			match(_t,LITERAL_sqrt);
			_t = _t->getFirstChild();
			a=fexpr(_t);
			_t = _retTree;
			_t = __t81;
			_t = _t->getNextSibling();
			if ( inputState->guessing==0 ) {
#line 733 "calc.g"
				r = sqrt(fabs(a));
#line 1193 "CalcWalker.cpp"
			}
			break;
		}
		case LITERAL_abs:
		{
			ANTLR_USE_NAMESPACE(antlr)RefAST __t82 = _t;
			ANTLR_USE_NAMESPACE(antlr)RefAST tmp33_AST_in = _t;
			match(_t,LITERAL_abs);
			_t = _t->getFirstChild();
			a=fexpr(_t);
			_t = _retTree;
			_t = __t82;
			_t = _t->getNextSibling();
			if ( inputState->guessing==0 ) {
#line 734 "calc.g"
				r = fabs(a);
#line 1210 "CalcWalker.cpp"
			}
			break;
		}
		case LITERAL_sin:
		{
			ANTLR_USE_NAMESPACE(antlr)RefAST __t83 = _t;
			ANTLR_USE_NAMESPACE(antlr)RefAST tmp34_AST_in = _t;
			match(_t,LITERAL_sin);
			_t = _t->getFirstChild();
			a=fexpr(_t);
			_t = _retTree;
			_t = __t83;
			_t = _t->getNextSibling();
			if ( inputState->guessing==0 ) {
#line 735 "calc.g"
				r = sin(a);
#line 1227 "CalcWalker.cpp"
			}
			break;
		}
		case LITERAL_cos:
		{
			ANTLR_USE_NAMESPACE(antlr)RefAST __t84 = _t;
			ANTLR_USE_NAMESPACE(antlr)RefAST tmp35_AST_in = _t;
			match(_t,LITERAL_cos);
			_t = _t->getFirstChild();
			a=fexpr(_t);
			_t = _retTree;
			_t = __t84;
			_t = _t->getNextSibling();
			if ( inputState->guessing==0 ) {
#line 736 "calc.g"
				r = cos(a);
#line 1244 "CalcWalker.cpp"
			}
			break;
		}
		case LITERAL_tan:
		{
			ANTLR_USE_NAMESPACE(antlr)RefAST __t85 = _t;
			ANTLR_USE_NAMESPACE(antlr)RefAST tmp36_AST_in = _t;
			match(_t,LITERAL_tan);
			_t = _t->getFirstChild();
			a=fexpr(_t);
			_t = _retTree;
			_t = __t85;
			_t = _t->getNextSibling();
			if ( inputState->guessing==0 ) {
#line 737 "calc.g"
				r = tan(a);
#line 1261 "CalcWalker.cpp"
			}
			break;
		}
		case LITERAL_acs:
		{
			ANTLR_USE_NAMESPACE(antlr)RefAST __t86 = _t;
			ANTLR_USE_NAMESPACE(antlr)RefAST tmp37_AST_in = _t;
			match(_t,LITERAL_acs);
			_t = _t->getFirstChild();
			a=fexpr(_t);
			_t = _retTree;
			_t = __t86;
			_t = _t->getNextSibling();
			if ( inputState->guessing==0 ) {
#line 738 "calc.g"
				r = acos(a);
#line 1278 "CalcWalker.cpp"
			}
			break;
		}
		case LITERAL_asn:
		{
			ANTLR_USE_NAMESPACE(antlr)RefAST __t87 = _t;
			ANTLR_USE_NAMESPACE(antlr)RefAST tmp38_AST_in = _t;
			match(_t,LITERAL_asn);
			_t = _t->getFirstChild();
			a=fexpr(_t);
			_t = _retTree;
			_t = __t87;
			_t = _t->getNextSibling();
			if ( inputState->guessing==0 ) {
#line 739 "calc.g"
				r = asin(a);
#line 1295 "CalcWalker.cpp"
			}
			break;
		}
		case LITERAL_exp:
		{
			ANTLR_USE_NAMESPACE(antlr)RefAST __t88 = _t;
			ANTLR_USE_NAMESPACE(antlr)RefAST tmp39_AST_in = _t;
			match(_t,LITERAL_exp);
			_t = _t->getFirstChild();
			a=fexpr(_t);
			_t = _retTree;
			_t = __t88;
			_t = _t->getNextSibling();
			if ( inputState->guessing==0 ) {
#line 740 "calc.g"
				r = exp(a);
#line 1312 "CalcWalker.cpp"
			}
			break;
		}
		case LITERAL_log:
		{
			ANTLR_USE_NAMESPACE(antlr)RefAST __t89 = _t;
			ANTLR_USE_NAMESPACE(antlr)RefAST tmp40_AST_in = _t;
			match(_t,LITERAL_log);
			_t = _t->getFirstChild();
			a=fexpr(_t);
			_t = _retTree;
			_t = __t89;
			_t = _t->getNextSibling();
			if ( inputState->guessing==0 ) {
#line 741 "calc.g"
				r = log(fabs(a));
#line 1329 "CalcWalker.cpp"
			}
			break;
		}
		case LITERAL_clic:
		case LITERAL_click:
		{
			{
			if (_t == ANTLR_USE_NAMESPACE(antlr)nullAST )
				_t = ASTNULL;
			switch ( _t->getType()) {
			case LITERAL_clic:
			{
				ANTLR_USE_NAMESPACE(antlr)RefAST tmp41_AST_in = _t;
				match(_t,LITERAL_clic);
				_t = _t->getNextSibling();
				break;
			}
			case LITERAL_click:
			{
				ANTLR_USE_NAMESPACE(antlr)RefAST tmp42_AST_in = _t;
				match(_t,LITERAL_click);
				_t = _t->getNextSibling();
				break;
			}
			default:
			{
				throw ANTLR_USE_NAMESPACE(antlr)NoViableAltException(_t);
			}
			}
			}
			if ( inputState->guessing==0 ) {
#line 742 "calc.g"
				r = WORLD.getClic();
#line 1363 "CalcWalker.cpp"
			}
			break;
		}
		case LITERAL_unclick:
		{
			ANTLR_USE_NAMESPACE(antlr)RefAST tmp43_AST_in = _t;
			match(_t,LITERAL_unclick);
			_t = _t->getNextSibling();
			if ( inputState->guessing==0 ) {
#line 743 "calc.g"
				r = WORLD.getUnClic();
#line 1375 "CalcWalker.cpp"
			}
			break;
		}
		case LITERAL_clicked:
		{
			ANTLR_USE_NAMESPACE(antlr)RefAST tmp44_AST_in = _t;
			match(_t,LITERAL_clicked);
			_t = _t->getNextSibling();
			if ( inputState->guessing==0 ) {
#line 744 "calc.g"
				r = WORLD.getClicked();
#line 1387 "CalcWalker.cpp"
			}
			break;
		}
		case LITERAL_key_left:
		{
			ANTLR_USE_NAMESPACE(antlr)RefAST tmp45_AST_in = _t;
			match(_t,LITERAL_key_left);
			_t = _t->getNextSibling();
			if ( inputState->guessing==0 ) {
#line 745 "calc.g"
				r = WORLD.isKeyPressed(KEY_LEFT);
#line 1399 "CalcWalker.cpp"
			}
			break;
		}
		case LITERAL_key_right:
		{
			ANTLR_USE_NAMESPACE(antlr)RefAST tmp46_AST_in = _t;
			match(_t,LITERAL_key_right);
			_t = _t->getNextSibling();
			if ( inputState->guessing==0 ) {
#line 746 "calc.g"
				r = WORLD.isKeyPressed(KEY_RIGHT);
#line 1411 "CalcWalker.cpp"
			}
			break;
		}
		case LITERAL_key_up:
		{
			ANTLR_USE_NAMESPACE(antlr)RefAST tmp47_AST_in = _t;
			match(_t,LITERAL_key_up);
			_t = _t->getNextSibling();
			if ( inputState->guessing==0 ) {
#line 747 "calc.g"
				r = WORLD.isKeyPressed(KEY_UP);
#line 1423 "CalcWalker.cpp"
			}
			break;
		}
		case LITERAL_key_down:
		{
			ANTLR_USE_NAMESPACE(antlr)RefAST tmp48_AST_in = _t;
			match(_t,LITERAL_key_down);
			_t = _t->getNextSibling();
			if ( inputState->guessing==0 ) {
#line 748 "calc.g"
				r = WORLD.isKeyPressed(KEY_DOWN);
#line 1435 "CalcWalker.cpp"
			}
			break;
		}
		case LITERAL_key_space:
		{
			ANTLR_USE_NAMESPACE(antlr)RefAST tmp49_AST_in = _t;
			match(_t,LITERAL_key_space);
			_t = _t->getNextSibling();
			if ( inputState->guessing==0 ) {
#line 749 "calc.g"
				r = WORLD.isKeyPressed(KEY_SPACE);
#line 1447 "CalcWalker.cpp"
			}
			break;
		}
		case LITERAL_rnd:
		{
			ANTLR_USE_NAMESPACE(antlr)RefAST tmp50_AST_in = _t;
			match(_t,LITERAL_rnd);
			_t = _t->getNextSibling();
			if ( inputState->guessing==0 ) {
#line 750 "calc.g"
				r = drand48();
#line 1459 "CalcWalker.cpp"
			}
			break;
		}
		case LITERAL_srnd:
		{
			ANTLR_USE_NAMESPACE(antlr)RefAST tmp51_AST_in = _t;
			match(_t,LITERAL_srnd);
			_t = _t->getNextSibling();
			if ( inputState->guessing==0 ) {
#line 751 "calc.g"
				r = 2.0 * drand48() - 1.0;
#line 1471 "CalcWalker.cpp"
			}
			break;
		}
		case LITERAL_ang:
		{
			ANTLR_USE_NAMESPACE(antlr)RefAST __t91 = _t;
			ANTLR_USE_NAMESPACE(antlr)RefAST tmp52_AST_in = _t;
			match(_t,LITERAL_ang);
			_t = _t->getFirstChild();
			a=fexpr(_t);
			_t = _retTree;
			b=fexpr(_t);
			_t = _retTree;
			_t = __t91;
			_t = _t->getNextSibling();
			if ( inputState->guessing==0 ) {
#line 752 "calc.g"
				r = atan2(b,a);
#line 1490 "CalcWalker.cpp"
			}
			break;
		}
		case LITERAL_min:
		{
			ANTLR_USE_NAMESPACE(antlr)RefAST __t92 = _t;
			ANTLR_USE_NAMESPACE(antlr)RefAST tmp53_AST_in = _t;
			match(_t,LITERAL_min);
			_t = _t->getFirstChild();
			a=fexpr(_t);
			_t = _retTree;
			b=fexpr(_t);
			_t = _retTree;
			_t = __t92;
			_t = _t->getNextSibling();
			if ( inputState->guessing==0 ) {
#line 753 "calc.g"
				r = (a < b) ? a : b;
#line 1509 "CalcWalker.cpp"
			}
			break;
		}
		case LITERAL_max:
		{
			ANTLR_USE_NAMESPACE(antlr)RefAST __t93 = _t;
			ANTLR_USE_NAMESPACE(antlr)RefAST tmp54_AST_in = _t;
			match(_t,LITERAL_max);
			_t = _t->getFirstChild();
			a=fexpr(_t);
			_t = _retTree;
			b=fexpr(_t);
			_t = _retTree;
			_t = __t93;
			_t = _t->getNextSibling();
			if ( inputState->guessing==0 ) {
#line 754 "calc.g"
				r = (a > b) ? a : b;
#line 1528 "CalcWalker.cpp"
			}
			break;
		}
		case LITERAL_int:
		{
			ANTLR_USE_NAMESPACE(antlr)RefAST __t94 = _t;
			ANTLR_USE_NAMESPACE(antlr)RefAST tmp55_AST_in = _t;
			match(_t,LITERAL_int);
			_t = _t->getFirstChild();
			a=fexpr(_t);
			_t = _retTree;
			_t = __t94;
			_t = _t->getNextSibling();
			if ( inputState->guessing==0 ) {
#line 755 "calc.g"
				r = floor(a);
#line 1545 "CalcWalker.cpp"
			}
			break;
		}
		case LITERAL_frac:
		{
			ANTLR_USE_NAMESPACE(antlr)RefAST __t95 = _t;
			ANTLR_USE_NAMESPACE(antlr)RefAST tmp56_AST_in = _t;
			match(_t,LITERAL_frac);
			_t = _t->getFirstChild();
			a=fexpr(_t);
			_t = _retTree;
			_t = __t95;
			_t = _t->getNextSibling();
			if ( inputState->guessing==0 ) {
#line 756 "calc.g"
				r = a-floor(a);
#line 1562 "CalcWalker.cpp"
			}
			break;
		}
		case LITERAL_sgn:
		{
			ANTLR_USE_NAMESPACE(antlr)RefAST __t96 = _t;
			ANTLR_USE_NAMESPACE(antlr)RefAST tmp57_AST_in = _t;
			match(_t,LITERAL_sgn);
			_t = _t->getFirstChild();
			a=fexpr(_t);
			_t = _retTree;
			_t = __t96;
			_t = _t->getNextSibling();
			if ( inputState->guessing==0 ) {
#line 757 "calc.g"
				r = (a<0.) ? -1. : (a>0.)? 1. : 0.;
#line 1579 "CalcWalker.cpp"
			}
			break;
		}
		case LITERAL_norm:
		{
			ANTLR_USE_NAMESPACE(antlr)RefAST __t97 = _t;
			ANTLR_USE_NAMESPACE(antlr)RefAST tmp58_AST_in = _t;
			match(_t,LITERAL_norm);
			_t = _t->getFirstChild();
			a=fexpr(_t);
			_t = _retTree;
			b=fexpr(_t);
			_t = _retTree;
			_t = __t97;
			_t = _t->getNextSibling();
			if ( inputState->guessing==0 ) {
#line 758 "calc.g"
				r = sqrt(a*a+b*b);
#line 1598 "CalcWalker.cpp"
			}
			break;
		}
		case LITERAL_mod:
		{
			ANTLR_USE_NAMESPACE(antlr)RefAST __t98 = _t;
			ANTLR_USE_NAMESPACE(antlr)RefAST tmp59_AST_in = _t;
			match(_t,LITERAL_mod);
			_t = _t->getFirstChild();
			a=fexpr(_t);
			_t = _retTree;
			b=fexpr(_t);
			_t = _retTree;
			_t = __t98;
			_t = _t->getNextSibling();
			if ( inputState->guessing==0 ) {
#line 760 "calc.g"
				
				int aa = (int)a;
				int bb = (int)b;
				if( bb == 0 )
				r = aa;
				else
				r = aa - floor((double)aa/(double)bb) * bb;
				
#line 1624 "CalcWalker.cpp"
			}
			break;
		}
		case LITERAL_dist:
		{
			ANTLR_USE_NAMESPACE(antlr)RefAST __t99 = _t;
			ANTLR_USE_NAMESPACE(antlr)RefAST tmp60_AST_in = _t;
			match(_t,LITERAL_dist);
			_t = _t->getFirstChild();
			mob=ref(_t);
			_t = _retTree;
			mob2=ref(_t);
			_t = _retTree;
			_t = __t99;
			_t = _t->getNextSibling();
			if ( inputState->guessing==0 ) {
#line 769 "calc.g"
				
				CMobile * mref  = getMobilePtr(mob);
				CMobile * mref2 = getMobilePtr(mob2);
				if ( mref && mref2 )
				r = mref->getPos().dist(mref2->getPos());
				else
					      { r = 0.0; warning(MSG_null_ref); }
				
#line 1650 "CalcWalker.cpp"
			}
			break;
		}
		case LITERAL_t:
		{
			ANTLR_USE_NAMESPACE(antlr)RefAST tmp61_AST_in = _t;
			match(_t,LITERAL_t);
			_t = _t->getNextSibling();
			if ( inputState->guessing==0 ) {
#line 778 "calc.g"
				r = WORLD.getTime();
#line 1662 "CalcWalker.cpp"
			}
			break;
		}
		case LITERAL_dt:
		{
			ANTLR_USE_NAMESPACE(antlr)RefAST tmp62_AST_in = _t;
			match(_t,LITERAL_dt);
			_t = _t->getNextSibling();
			if ( inputState->guessing==0 ) {
#line 779 "calc.g"
				r = WORLD.getTimeInterval();
#line 1674 "CalcWalker.cpp"
			}
			break;
		}
		case LITERAL_x:
		{
			ANTLR_USE_NAMESPACE(antlr)RefAST __t100 = _t;
			ANTLR_USE_NAMESPACE(antlr)RefAST tmp63_AST_in = _t;
			match(_t,LITERAL_x);
			_t = _t->getFirstChild();
			mob=ref(_t);
			_t = _retTree;
			_t = __t100;
			_t = _t->getNextSibling();
			if ( inputState->guessing==0 ) {
#line 780 "calc.g"
				r = get_atr_nfo(ATTR_X,  mob, 0);
#line 1691 "CalcWalker.cpp"
			}
			break;
		}
		case LITERAL_y:
		{
			ANTLR_USE_NAMESPACE(antlr)RefAST __t101 = _t;
			ANTLR_USE_NAMESPACE(antlr)RefAST tmp64_AST_in = _t;
			match(_t,LITERAL_y);
			_t = _t->getFirstChild();
			mob=ref(_t);
			_t = _retTree;
			_t = __t101;
			_t = _t->getNextSibling();
			if ( inputState->guessing==0 ) {
#line 781 "calc.g"
				r = get_atr_nfo(ATTR_Y,  mob, 0);
#line 1708 "CalcWalker.cpp"
			}
			break;
		}
		case LITERAL_dx:
		{
			ANTLR_USE_NAMESPACE(antlr)RefAST __t102 = _t;
			ANTLR_USE_NAMESPACE(antlr)RefAST tmp65_AST_in = _t;
			match(_t,LITERAL_dx);
			_t = _t->getFirstChild();
			mob=ref(_t);
			_t = _retTree;
			_t = __t102;
			_t = _t->getNextSibling();
			if ( inputState->guessing==0 ) {
#line 782 "calc.g"
				r = get_atr_nfo(ATTR_DX, mob, 0);
#line 1725 "CalcWalker.cpp"
			}
			break;
		}
		case LITERAL_dy:
		{
			ANTLR_USE_NAMESPACE(antlr)RefAST __t103 = _t;
			ANTLR_USE_NAMESPACE(antlr)RefAST tmp66_AST_in = _t;
			match(_t,LITERAL_dy);
			_t = _t->getFirstChild();
			mob=ref(_t);
			_t = _retTree;
			_t = __t103;
			_t = _t->getNextSibling();
			if ( inputState->guessing==0 ) {
#line 783 "calc.g"
				r = get_atr_nfo(ATTR_DY, mob, 0);
#line 1742 "CalcWalker.cpp"
			}
			break;
		}
		case LITERAL_angle:
		{
			ANTLR_USE_NAMESPACE(antlr)RefAST __t104 = _t;
			ANTLR_USE_NAMESPACE(antlr)RefAST tmp67_AST_in = _t;
			match(_t,LITERAL_angle);
			_t = _t->getFirstChild();
			mob=ref(_t);
			_t = _retTree;
			_t = __t104;
			_t = _t->getNextSibling();
			if ( inputState->guessing==0 ) {
#line 784 "calc.g"
				r = get_atr_nfo(ATTR_ANGLE, mob, 0);
#line 1759 "CalcWalker.cpp"
			}
			break;
		}
		case LITERAL_icon:
		{
			ANTLR_USE_NAMESPACE(antlr)RefAST __t105 = _t;
			ANTLR_USE_NAMESPACE(antlr)RefAST tmp68_AST_in = _t;
			match(_t,LITERAL_icon);
			_t = _t->getFirstChild();
			mob=ref(_t);
			_t = _retTree;
			_t = __t105;
			_t = _t->getNextSibling();
			if ( inputState->guessing==0 ) {
#line 785 "calc.g"
				r = get_atr_nfo(ATTR_ICONE, mob, 0);
#line 1776 "CalcWalker.cpp"
			}
			break;
		}
		case LITERAL_color:
		{
			ANTLR_USE_NAMESPACE(antlr)RefAST __t106 = _t;
			ANTLR_USE_NAMESPACE(antlr)RefAST tmp69_AST_in = _t;
			match(_t,LITERAL_color);
			_t = _t->getFirstChild();
			mob=ref(_t);
			_t = _retTree;
			_t = __t106;
			_t = _t->getNextSibling();
			if ( inputState->guessing==0 ) {
#line 786 "calc.g"
				r = get_atr_nfo(ATTR_COULEUR, mob, 0);
#line 1793 "CalcWalker.cpp"
			}
			break;
		}
		case LITERAL_red:
		{
			ANTLR_USE_NAMESPACE(antlr)RefAST __t107 = _t;
			ANTLR_USE_NAMESPACE(antlr)RefAST tmp70_AST_in = _t;
			match(_t,LITERAL_red);
			_t = _t->getFirstChild();
			mob=ref(_t);
			_t = _retTree;
			_t = __t107;
			_t = _t->getNextSibling();
			if ( inputState->guessing==0 ) {
#line 787 "calc.g"
				r = get_atr_nfo(ATTR_ROUGE, mob, 0);
#line 1810 "CalcWalker.cpp"
			}
			break;
		}
		case LITERAL_green:
		{
			ANTLR_USE_NAMESPACE(antlr)RefAST __t108 = _t;
			ANTLR_USE_NAMESPACE(antlr)RefAST tmp71_AST_in = _t;
			match(_t,LITERAL_green);
			_t = _t->getFirstChild();
			mob=ref(_t);
			_t = _retTree;
			_t = __t108;
			_t = _t->getNextSibling();
			if ( inputState->guessing==0 ) {
#line 788 "calc.g"
				r = get_atr_nfo(ATTR_VERT, mob, 0);
#line 1827 "CalcWalker.cpp"
			}
			break;
		}
		case LITERAL_blue:
		{
			ANTLR_USE_NAMESPACE(antlr)RefAST __t109 = _t;
			ANTLR_USE_NAMESPACE(antlr)RefAST tmp72_AST_in = _t;
			match(_t,LITERAL_blue);
			_t = _t->getFirstChild();
			mob=ref(_t);
			_t = _retTree;
			_t = __t109;
			_t = _t->getNextSibling();
			if ( inputState->guessing==0 ) {
#line 789 "calc.g"
				r = get_atr_nfo(ATTR_BLEU, mob, 0);
#line 1844 "CalcWalker.cpp"
			}
			break;
		}
		case LITERAL_gray:
		{
			ANTLR_USE_NAMESPACE(antlr)RefAST __t110 = _t;
			ANTLR_USE_NAMESPACE(antlr)RefAST tmp73_AST_in = _t;
			match(_t,LITERAL_gray);
			_t = _t->getFirstChild();
			mob=ref(_t);
			_t = _retTree;
			_t = __t110;
			_t = _t->getNextSibling();
			if ( inputState->guessing==0 ) {
#line 790 "calc.g"
				r = get_atr_nfo(ATTR_GRIS, mob, 0);
#line 1861 "CalcWalker.cpp"
			}
			break;
		}
		case LITERAL_shockx:
		{
			ANTLR_USE_NAMESPACE(antlr)RefAST __t111 = _t;
			ANTLR_USE_NAMESPACE(antlr)RefAST tmp74_AST_in = _t;
			match(_t,LITERAL_shockx);
			_t = _t->getFirstChild();
			mob=ref(_t);
			_t = _retTree;
			_t = __t111;
			_t = _t->getNextSibling();
			if ( inputState->guessing==0 ) {
#line 791 "calc.g"
				r = get_atr_nfo(ATTR_CHOCX, mob, 0);
#line 1878 "CalcWalker.cpp"
			}
			break;
		}
		case LITERAL_shocky:
		{
			ANTLR_USE_NAMESPACE(antlr)RefAST __t112 = _t;
			ANTLR_USE_NAMESPACE(antlr)RefAST tmp75_AST_in = _t;
			match(_t,LITERAL_shocky);
			_t = _t->getFirstChild();
			mob=ref(_t);
			_t = _retTree;
			_t = __t112;
			_t = _t->getNextSibling();
			if ( inputState->guessing==0 ) {
#line 792 "calc.g"
				r = get_atr_nfo(ATTR_CHOCY, mob, 0);
#line 1895 "CalcWalker.cpp"
			}
			break;
		}
		case LITERAL_width:
		{
			ANTLR_USE_NAMESPACE(antlr)RefAST __t113 = _t;
			ANTLR_USE_NAMESPACE(antlr)RefAST tmp76_AST_in = _t;
			match(_t,LITERAL_width);
			_t = _t->getFirstChild();
			mob=ref(_t);
			_t = _retTree;
			_t = __t113;
			_t = _t->getNextSibling();
			if ( inputState->guessing==0 ) {
#line 793 "calc.g"
				r = get_atr_nfo(ATTR_LARGEUR, mob, 0);
#line 1912 "CalcWalker.cpp"
			}
			break;
		}
		case LITERAL_height:
		{
			ANTLR_USE_NAMESPACE(antlr)RefAST __t114 = _t;
			ANTLR_USE_NAMESPACE(antlr)RefAST tmp77_AST_in = _t;
			match(_t,LITERAL_height);
			_t = _t->getFirstChild();
			mob=ref(_t);
			_t = _retTree;
			_t = __t114;
			_t = _t->getNextSibling();
			if ( inputState->guessing==0 ) {
#line 794 "calc.g"
				r = get_atr_nfo(ATTR_HAUTEUR, mob, 0);
#line 1929 "CalcWalker.cpp"
			}
			break;
		}
		case LITERAL_zoom:
		{
			ANTLR_USE_NAMESPACE(antlr)RefAST __t115 = _t;
			ANTLR_USE_NAMESPACE(antlr)RefAST tmp78_AST_in = _t;
			match(_t,LITERAL_zoom);
			_t = _t->getFirstChild();
			mob=ref(_t);
			_t = _retTree;
			_t = __t115;
			_t = _t->getNextSibling();
			if ( inputState->guessing==0 ) {
#line 795 "calc.g"
				r = get_atr_nfo(ATTR_HAUTEUR, mob, 0);
#line 1946 "CalcWalker.cpp"
			}
			break;
		}
		case LITERAL_visible:
		{
			ANTLR_USE_NAMESPACE(antlr)RefAST __t116 = _t;
			ANTLR_USE_NAMESPACE(antlr)RefAST tmp79_AST_in = _t;
			match(_t,LITERAL_visible);
			_t = _t->getFirstChild();
			mob=ref(_t);
			_t = _retTree;
			_t = __t116;
			_t = _t->getNextSibling();
			if ( inputState->guessing==0 ) {
#line 796 "calc.g"
				r = get_atr_nfo(ATTR_VISIBLE, mob, 0);
#line 1963 "CalcWalker.cpp"
			}
			break;
		}
		case LITERAL_contact:
		{
			ANTLR_USE_NAMESPACE(antlr)RefAST __t117 = _t;
			ANTLR_USE_NAMESPACE(antlr)RefAST tmp80_AST_in = _t;
			match(_t,LITERAL_contact);
			_t = _t->getFirstChild();
			mob=ref(_t);
			_t = _retTree;
			_t = __t117;
			_t = _t->getNextSibling();
			if ( inputState->guessing==0 ) {
#line 797 "calc.g"
				r = get_atr_nfo(ATTR_CONTACT, mob, 0);
#line 1980 "CalcWalker.cpp"
			}
			break;
		}
		case LITERAL_mem:
		{
			ANTLR_USE_NAMESPACE(antlr)RefAST __t118 = _t;
			va = (_t == ASTNULL) ? ANTLR_USE_NAMESPACE(antlr)nullAST : _t;
			match(_t,LITERAL_mem);
			_t = _t->getFirstChild();
			mob=ref(_t);
			_t = _retTree;
			_t = __t118;
			_t = _t->getNextSibling();
			if ( inputState->guessing==0 ) {
#line 798 "calc.g"
				r = get_atr_nfo(ATTR_VAR, mob, atoi(va->getText().c_str()));
#line 1997 "CalcWalker.cpp"
			}
			break;
		}
		case GREATER:
		{
			ANTLR_USE_NAMESPACE(antlr)RefAST __t167 = _t;
			ANTLR_USE_NAMESPACE(antlr)RefAST tmp81_AST_in = _t;
			match(_t,GREATER);
			_t = _t->getFirstChild();
			a=fexpr(_t);
			_t = _retTree;
			b=fexpr(_t);
			_t = _retTree;
			_t = __t167;
			_t = _t->getNextSibling();
			if ( inputState->guessing==0 ) {
#line 913 "calc.g"
				if( a >  b ) r = 1.0; else r = 0.0;
#line 2016 "CalcWalker.cpp"
			}
			break;
		}
		case GEQ:
		{
			ANTLR_USE_NAMESPACE(antlr)RefAST __t168 = _t;
			ANTLR_USE_NAMESPACE(antlr)RefAST tmp82_AST_in = _t;
			match(_t,GEQ);
			_t = _t->getFirstChild();
			a=fexpr(_t);
			_t = _retTree;
			b=fexpr(_t);
			_t = _retTree;
			_t = __t168;
			_t = _t->getNextSibling();
			if ( inputState->guessing==0 ) {
#line 914 "calc.g"
				if( a >= b ) r = 1.0; else r = 0.0;
#line 2035 "CalcWalker.cpp"
			}
			break;
		}
		case LESS:
		{
			ANTLR_USE_NAMESPACE(antlr)RefAST __t169 = _t;
			ANTLR_USE_NAMESPACE(antlr)RefAST tmp83_AST_in = _t;
			match(_t,LESS);
			_t = _t->getFirstChild();
			a=fexpr(_t);
			_t = _retTree;
			b=fexpr(_t);
			_t = _retTree;
			_t = __t169;
			_t = _t->getNextSibling();
			if ( inputState->guessing==0 ) {
#line 915 "calc.g"
				if( a <  b ) r = 1.0; else r = 0.0;
#line 2054 "CalcWalker.cpp"
			}
			break;
		}
		case LEQ:
		{
			ANTLR_USE_NAMESPACE(antlr)RefAST __t170 = _t;
			ANTLR_USE_NAMESPACE(antlr)RefAST tmp84_AST_in = _t;
			match(_t,LEQ);
			_t = _t->getFirstChild();
			a=fexpr(_t);
			_t = _retTree;
			b=fexpr(_t);
			_t = _retTree;
			_t = __t170;
			_t = _t->getNextSibling();
			if ( inputState->guessing==0 ) {
#line 916 "calc.g"
				if( a <= b ) r = 1.0; else r = 0.0;
#line 2073 "CalcWalker.cpp"
			}
			break;
		}
		case LITERAL_and:
		{
			ANTLR_USE_NAMESPACE(antlr)RefAST __t171 = _t;
			ANTLR_USE_NAMESPACE(antlr)RefAST tmp85_AST_in = _t;
			match(_t,LITERAL_and);
			_t = _t->getFirstChild();
			a=fexpr(_t);
			_t = _retTree;
			b=fexpr(_t);
			_t = _retTree;
			_t = __t171;
			_t = _t->getNextSibling();
			if ( inputState->guessing==0 ) {
#line 917 "calc.g"
				if( ( a != 0.0 ) && ( b != 0.0 ) ) r = 1.0; else r = 0.0;
#line 2092 "CalcWalker.cpp"
			}
			break;
		}
		case LITERAL_or:
		{
			ANTLR_USE_NAMESPACE(antlr)RefAST __t172 = _t;
			ANTLR_USE_NAMESPACE(antlr)RefAST tmp86_AST_in = _t;
			match(_t,LITERAL_or);
			_t = _t->getFirstChild();
			a=fexpr(_t);
			_t = _retTree;
			b=fexpr(_t);
			_t = _retTree;
			_t = __t172;
			_t = _t->getNextSibling();
			if ( inputState->guessing==0 ) {
#line 918 "calc.g"
				if( ( a != 0.0 ) || ( b != 0.0 ) ) r = 1.0; else r = 0.0;
#line 2111 "CalcWalker.cpp"
			}
			break;
		}
		case ID:
		{
			id = _t;
			match(_t,ID);
			_t = _t->getNextSibling();
			if ( inputState->guessing==0 ) {
#line 922 "calc.g"
				
				double * fref = getFloatRef(id->getText(), MUST_EXIST);
					    // cerr << "[DEBUG] ID=fexp\n";
				if( fref )
				r = *fref;
				else
					      { r = 0.0; warning(MSG_undef_f); }
				
#line 2130 "CalcWalker.cpp"
			}
			break;
		}
		default:
			bool synPredMatched70 = false;
			if (((_t->getType() == PLUS))) {
				ANTLR_USE_NAMESPACE(antlr)RefAST __t70 = _t;
				synPredMatched70 = true;
				inputState->guessing++;
				try {
					{
					ANTLR_USE_NAMESPACE(antlr)RefAST __t69 = _t;
					ANTLR_USE_NAMESPACE(antlr)RefAST tmp87_AST_in = _t;
					match(_t,PLUS);
					_t = _t->getFirstChild();
					fexpr(_t);
					_t = _retTree;
					fexpr(_t);
					_t = _retTree;
					_t = __t69;
					_t = _t->getNextSibling();
					}
				}
				catch (ANTLR_USE_NAMESPACE(antlr)RecognitionException& pe) {
					synPredMatched70 = false;
				}
				_t = __t70;
				inputState->guessing--;
			}
			if ( synPredMatched70 ) {
				ANTLR_USE_NAMESPACE(antlr)RefAST __t71 = _t;
				ANTLR_USE_NAMESPACE(antlr)RefAST tmp88_AST_in = _t;
				match(_t,PLUS);
				_t = _t->getFirstChild();
				a=fexpr(_t);
				_t = _retTree;
				b=fexpr(_t);
				_t = _retTree;
				_t = __t71;
				_t = _t->getNextSibling();
				if ( inputState->guessing==0 ) {
#line 721 "calc.g"
					r = a + b;
#line 2174 "CalcWalker.cpp"
				}
			}
			else if ((_t->getType() == PLUS)) {
				ANTLR_USE_NAMESPACE(antlr)RefAST __t72 = _t;
				ANTLR_USE_NAMESPACE(antlr)RefAST tmp89_AST_in = _t;
				match(_t,PLUS);
				_t = _t->getFirstChild();
				a=fexpr(_t);
				_t = _retTree;
				_t = __t72;
				_t = _t->getNextSibling();
				if ( inputState->guessing==0 ) {
#line 722 "calc.g"
					r = a;
#line 2189 "CalcWalker.cpp"
				}
			}
			else {
				bool synPredMatched75 = false;
				if (((_t->getType() == MINUS))) {
					ANTLR_USE_NAMESPACE(antlr)RefAST __t75 = _t;
					synPredMatched75 = true;
					inputState->guessing++;
					try {
						{
						ANTLR_USE_NAMESPACE(antlr)RefAST __t74 = _t;
						ANTLR_USE_NAMESPACE(antlr)RefAST tmp90_AST_in = _t;
						match(_t,MINUS);
						_t = _t->getFirstChild();
						fexpr(_t);
						_t = _retTree;
						fexpr(_t);
						_t = _retTree;
						_t = __t74;
						_t = _t->getNextSibling();
						}
					}
					catch (ANTLR_USE_NAMESPACE(antlr)RecognitionException& pe) {
						synPredMatched75 = false;
					}
					_t = __t75;
					inputState->guessing--;
				}
				if ( synPredMatched75 ) {
					ANTLR_USE_NAMESPACE(antlr)RefAST __t76 = _t;
					ANTLR_USE_NAMESPACE(antlr)RefAST tmp91_AST_in = _t;
					match(_t,MINUS);
					_t = _t->getFirstChild();
					a=fexpr(_t);
					_t = _retTree;
					b=fexpr(_t);
					_t = _retTree;
					_t = __t76;
					_t = _t->getNextSibling();
					if ( inputState->guessing==0 ) {
#line 723 "calc.g"
						r =  a - b;
#line 2232 "CalcWalker.cpp"
					}
				}
				else if ((_t->getType() == MINUS)) {
					ANTLR_USE_NAMESPACE(antlr)RefAST __t77 = _t;
					ANTLR_USE_NAMESPACE(antlr)RefAST tmp92_AST_in = _t;
					match(_t,MINUS);
					_t = _t->getFirstChild();
					a=fexpr(_t);
					_t = _retTree;
					_t = __t77;
					_t = _t->getNextSibling();
					if ( inputState->guessing==0 ) {
#line 724 "calc.g"
						r = -a;
#line 2247 "CalcWalker.cpp"
					}
				}
				else {
					bool synPredMatched121 = false;
					if (((_t->getType() == EQUAL))) {
						ANTLR_USE_NAMESPACE(antlr)RefAST __t121 = _t;
						synPredMatched121 = true;
						inputState->guessing++;
						try {
							{
							ANTLR_USE_NAMESPACE(antlr)RefAST __t120 = _t;
							ANTLR_USE_NAMESPACE(antlr)RefAST tmp93_AST_in = _t;
							match(_t,EQUAL);
							_t = _t->getFirstChild();
							ANTLR_USE_NAMESPACE(antlr)RefAST tmp94_AST_in = _t;
							match(_t,ID);
							_t = _t->getNextSibling();
							ANTLR_USE_NAMESPACE(antlr)RefAST tmp95_AST_in = _t;
							match(_t,ID);
							_t = _t->getNextSibling();
							_t = __t120;
							_t = _t->getNextSibling();
							}
						}
						catch (ANTLR_USE_NAMESPACE(antlr)RecognitionException& pe) {
							synPredMatched121 = false;
						}
						_t = __t121;
						inputState->guessing--;
					}
					if ( synPredMatched121 ) {
						ANTLR_USE_NAMESPACE(antlr)RefAST __t122 = _t;
						ANTLR_USE_NAMESPACE(antlr)RefAST tmp96_AST_in = _t;
						match(_t,EQUAL);
						_t = _t->getFirstChild();
						id1 = _t;
						match(_t,ID);
						_t = _t->getNextSibling();
						id2 = _t;
						match(_t,ID);
						_t = _t->getNextSibling();
						_t = __t122;
						_t = _t->getNextSibling();
						if ( inputState->guessing==0 ) {
#line 802 "calc.g"
							
							// std::cerr << "[DEBUG] id EQUAL id ?\n";
							mob_adress *mref1 = getMobileRef(id1->getText());
							mob_adress *mref2 = getMobileRef(id2->getText());
							if (mref1 && mref2)
							r = (areMobilesEqual(*mref1, *mref2)) ? 1.0 : 0.0;
							else
							if ((!mref1)&&(!mref2)) {
								double *floatref1 = getFloatRef(id1->getText(),MUST_EXIST);
								double *floatref2 = getFloatRef(id2->getText(),MUST_EXIST);
								r = (*floatref1 == *floatref2) ? 1.0 : 0.0;
							}
							else
							if (mref1) 
							r = (isMobileEqualN(*mref1, *getFloatRef(id2->getText(),MUST_EXIST))) ? 1.0 : 0.0;
							else
							r = (isMobileEqualN(*mref2, *getFloatRef(id1->getText(),MUST_EXIST))) ? 1.0 : 0.0;
							
#line 2311 "CalcWalker.cpp"
						}
					}
					else {
						bool synPredMatched125 = false;
						if (((_t->getType() == EQUAL))) {
							ANTLR_USE_NAMESPACE(antlr)RefAST __t125 = _t;
							synPredMatched125 = true;
							inputState->guessing++;
							try {
								{
								ANTLR_USE_NAMESPACE(antlr)RefAST __t124 = _t;
								ANTLR_USE_NAMESPACE(antlr)RefAST tmp97_AST_in = _t;
								match(_t,EQUAL);
								_t = _t->getFirstChild();
								ANTLR_USE_NAMESPACE(antlr)RefAST tmp98_AST_in = _t;
								match(_t,ID);
								_t = _t->getNextSibling();
								ref(_t);
								_t = _retTree;
								_t = __t124;
								_t = _t->getNextSibling();
								}
							}
							catch (ANTLR_USE_NAMESPACE(antlr)RecognitionException& pe) {
								synPredMatched125 = false;
							}
							_t = __t125;
							inputState->guessing--;
						}
						if ( synPredMatched125 ) {
							ANTLR_USE_NAMESPACE(antlr)RefAST __t126 = _t;
							ANTLR_USE_NAMESPACE(antlr)RefAST tmp99_AST_in = _t;
							match(_t,EQUAL);
							_t = _t->getFirstChild();
							id3 = _t;
							match(_t,ID);
							_t = _t->getNextSibling();
							mob2=ref(_t);
							_t = _retTree;
							_t = __t126;
							_t = _t->getNextSibling();
							if ( inputState->guessing==0 ) {
#line 821 "calc.g"
								
								mob_adress *mref = getMobileRef(id3->getText());
								if (mref)
								r = (areMobilesEqual(*mref, mob2)) ? 1.0 : 0.0;
								else {
									double* floatref = getFloatRef(id3->getText(),MUST_EXIST);
									// printf("id=ref %d\n",*floatref==(int)*floatref);
									r = (*floatref == conv_ref_to_number(mob2)) ? 1.0 : 0.0;
								}
								
#line 2365 "CalcWalker.cpp"
							}
						}
						else {
							bool synPredMatched129 = false;
							if (((_t->getType() == EQUAL))) {
								ANTLR_USE_NAMESPACE(antlr)RefAST __t129 = _t;
								synPredMatched129 = true;
								inputState->guessing++;
								try {
									{
									ANTLR_USE_NAMESPACE(antlr)RefAST __t128 = _t;
									ANTLR_USE_NAMESPACE(antlr)RefAST tmp100_AST_in = _t;
									match(_t,EQUAL);
									_t = _t->getFirstChild();
									ref(_t);
									_t = _retTree;
									ANTLR_USE_NAMESPACE(antlr)RefAST tmp101_AST_in = _t;
									match(_t,ID);
									_t = _t->getNextSibling();
									_t = __t128;
									_t = _t->getNextSibling();
									}
								}
								catch (ANTLR_USE_NAMESPACE(antlr)RecognitionException& pe) {
									synPredMatched129 = false;
								}
								_t = __t129;
								inputState->guessing--;
							}
							if ( synPredMatched129 ) {
								ANTLR_USE_NAMESPACE(antlr)RefAST __t130 = _t;
								ANTLR_USE_NAMESPACE(antlr)RefAST tmp102_AST_in = _t;
								match(_t,EQUAL);
								_t = _t->getFirstChild();
								mob2=ref(_t);
								_t = _retTree;
								id4 = _t;
								match(_t,ID);
								_t = _t->getNextSibling();
								_t = __t130;
								_t = _t->getNextSibling();
								if ( inputState->guessing==0 ) {
#line 832 "calc.g"
									
									// std::cerr << "[DEBUG] ref EQUAL id ?\n";
									mob_adress *mref = getMobileRef(id4->getText());
									if (mref) {
									r = (areMobilesEqual(*mref, mob2)) ? 1.0 : 0.0;
									}
									else {
										double* floatref = getFloatRef(id4->getText(),MUST_EXIST);
										r = ((*floatref) == conv_ref_to_number(mob2)) ? 1.0 : 0.0;
									}
									
#line 2420 "CalcWalker.cpp"
								}
							}
							else {
								bool synPredMatched133 = false;
								if (((_t->getType() == EQUAL))) {
									ANTLR_USE_NAMESPACE(antlr)RefAST __t133 = _t;
									synPredMatched133 = true;
									inputState->guessing++;
									try {
										{
										ANTLR_USE_NAMESPACE(antlr)RefAST __t132 = _t;
										ANTLR_USE_NAMESPACE(antlr)RefAST tmp103_AST_in = _t;
										match(_t,EQUAL);
										_t = _t->getFirstChild();
										fexpr(_t);
										_t = _retTree;
										fexpr(_t);
										_t = _retTree;
										_t = __t132;
										_t = _t->getNextSibling();
										}
									}
									catch (ANTLR_USE_NAMESPACE(antlr)RecognitionException& pe) {
										synPredMatched133 = false;
									}
									_t = __t133;
									inputState->guessing--;
								}
								if ( synPredMatched133 ) {
									ANTLR_USE_NAMESPACE(antlr)RefAST __t134 = _t;
									ANTLR_USE_NAMESPACE(antlr)RefAST tmp104_AST_in = _t;
									match(_t,EQUAL);
									_t = _t->getFirstChild();
									a=fexpr(_t);
									_t = _retTree;
									b=fexpr(_t);
									_t = _retTree;
									_t = __t134;
									_t = _t->getNextSibling();
									if ( inputState->guessing==0 ) {
#line 844 "calc.g"
										
										// std::cerr << "[DEBUG] fexpr EQUAL fexpr ?\n";
										if( a == b ) r = 1.0; else r = 0.0;
										
#line 2466 "CalcWalker.cpp"
									}
								}
								else {
									bool synPredMatched137 = false;
									if (((_t->getType() == EQUAL))) {
										ANTLR_USE_NAMESPACE(antlr)RefAST __t137 = _t;
										synPredMatched137 = true;
										inputState->guessing++;
										try {
											{
											ANTLR_USE_NAMESPACE(antlr)RefAST __t136 = _t;
											ANTLR_USE_NAMESPACE(antlr)RefAST tmp105_AST_in = _t;
											match(_t,EQUAL);
											_t = _t->getFirstChild();
											ref(_t);
											_t = _retTree;
											ref(_t);
											_t = _retTree;
											_t = __t136;
											_t = _t->getNextSibling();
											}
										}
										catch (ANTLR_USE_NAMESPACE(antlr)RecognitionException& pe) {
											synPredMatched137 = false;
										}
										_t = __t137;
										inputState->guessing--;
									}
									if ( synPredMatched137 ) {
										ANTLR_USE_NAMESPACE(antlr)RefAST __t138 = _t;
										ANTLR_USE_NAMESPACE(antlr)RefAST tmp106_AST_in = _t;
										match(_t,EQUAL);
										_t = _t->getFirstChild();
										mob=ref(_t);
										_t = _retTree;
										mob2=ref(_t);
										_t = _retTree;
										_t = __t138;
										_t = _t->getNextSibling();
										if ( inputState->guessing==0 ) {
#line 849 "calc.g"
											
												// std::cerr << "[DEBUG] ref EQUAL ref ?\n";
												if (areMobilesEqual(mob,mob2))  r = 1.0; else r = 0.0;
												// if( getMobilePtr(mob) == getMobilePtr(mob2) ) r = 1.0; else r = 0.0;
											
#line 2513 "CalcWalker.cpp"
										}
									}
									else {
										bool synPredMatched141 = false;
										if (((_t->getType() == EQUAL))) {
											ANTLR_USE_NAMESPACE(antlr)RefAST __t141 = _t;
											synPredMatched141 = true;
											inputState->guessing++;
											try {
												{
												ANTLR_USE_NAMESPACE(antlr)RefAST __t140 = _t;
												ANTLR_USE_NAMESPACE(antlr)RefAST tmp107_AST_in = _t;
												match(_t,EQUAL);
												_t = _t->getFirstChild();
												ref(_t);
												_t = _retTree;
												fexpr(_t);
												_t = _retTree;
												_t = __t140;
												_t = _t->getNextSibling();
												}
											}
											catch (ANTLR_USE_NAMESPACE(antlr)RecognitionException& pe) {
												synPredMatched141 = false;
											}
											_t = __t141;
											inputState->guessing--;
										}
										if ( synPredMatched141 ) {
											ANTLR_USE_NAMESPACE(antlr)RefAST __t142 = _t;
											ANTLR_USE_NAMESPACE(antlr)RefAST tmp108_AST_in = _t;
											match(_t,EQUAL);
											_t = _t->getFirstChild();
											mob=ref(_t);
											_t = _retTree;
											a=fexpr(_t);
											_t = _retTree;
											_t = __t142;
											_t = _t->getNextSibling();
											if ( inputState->guessing==0 ) {
#line 855 "calc.g"
												
													// std::cerr << "[DEBUG] ref EQUAL fexpr ?\n";
													if (isMobileEqualN(mob,a))   r = 1.0; else r = 0.0;
												
#line 2559 "CalcWalker.cpp"
											}
										}
										else {
											bool synPredMatched145 = false;
											if (((_t->getType() == EQUAL))) {
												ANTLR_USE_NAMESPACE(antlr)RefAST __t145 = _t;
												synPredMatched145 = true;
												inputState->guessing++;
												try {
													{
													ANTLR_USE_NAMESPACE(antlr)RefAST __t144 = _t;
													ANTLR_USE_NAMESPACE(antlr)RefAST tmp109_AST_in = _t;
													match(_t,EQUAL);
													_t = _t->getFirstChild();
													fexpr(_t);
													_t = _retTree;
													ref(_t);
													_t = _retTree;
													_t = __t144;
													_t = _t->getNextSibling();
													}
												}
												catch (ANTLR_USE_NAMESPACE(antlr)RecognitionException& pe) {
													synPredMatched145 = false;
												}
												_t = __t145;
												inputState->guessing--;
											}
											if ( synPredMatched145 ) {
												ANTLR_USE_NAMESPACE(antlr)RefAST __t146 = _t;
												ANTLR_USE_NAMESPACE(antlr)RefAST tmp110_AST_in = _t;
												match(_t,EQUAL);
												_t = _t->getFirstChild();
												a=fexpr(_t);
												_t = _retTree;
												mob=ref(_t);
												_t = _retTree;
												_t = __t146;
												_t = _t->getNextSibling();
												if ( inputState->guessing==0 ) {
#line 860 "calc.g"
													
														// std::cerr << "[DEBUG] fexpr EQUAL ref ?\n";
														if (isMobileEqualN(mob,a))   r = 1.0; else r = 0.0;
													
#line 2605 "CalcWalker.cpp"
												}
											}
											else {
												bool synPredMatched149 = false;
												if (((_t->getType() == NEQ))) {
													ANTLR_USE_NAMESPACE(antlr)RefAST __t149 = _t;
													synPredMatched149 = true;
													inputState->guessing++;
													try {
														{
														ANTLR_USE_NAMESPACE(antlr)RefAST __t148 = _t;
														ANTLR_USE_NAMESPACE(antlr)RefAST tmp111_AST_in = _t;
														match(_t,NEQ);
														_t = _t->getFirstChild();
														ANTLR_USE_NAMESPACE(antlr)RefAST tmp112_AST_in = _t;
														match(_t,ID);
														_t = _t->getNextSibling();
														ANTLR_USE_NAMESPACE(antlr)RefAST tmp113_AST_in = _t;
														match(_t,ID);
														_t = _t->getNextSibling();
														_t = __t148;
														_t = _t->getNextSibling();
														}
													}
													catch (ANTLR_USE_NAMESPACE(antlr)RecognitionException& pe) {
														synPredMatched149 = false;
													}
													_t = __t149;
													inputState->guessing--;
												}
												if ( synPredMatched149 ) {
													ANTLR_USE_NAMESPACE(antlr)RefAST __t150 = _t;
													ANTLR_USE_NAMESPACE(antlr)RefAST tmp114_AST_in = _t;
													match(_t,NEQ);
													_t = _t->getFirstChild();
													id_1 = _t;
													match(_t,ID);
													_t = _t->getNextSibling();
													id_2 = _t;
													match(_t,ID);
													_t = _t->getNextSibling();
													_t = __t150;
													_t = _t->getNextSibling();
													if ( inputState->guessing==0 ) {
#line 867 "calc.g"
														
														mob_adress *mref1 = getMobileRef(id_1->getText());
														mob_adress *mref2 = getMobileRef(id_2->getText());
														if (mref1 && mref2)
														r = (!areMobilesEqual(*mref1, *mref2)) ? 1.0 : 0.0;
														else
														if ((!mref1)&&(!mref2)) {
															double *floatref1 = getFloatRef(id_1->getText(),MUST_EXIST);
															double *floatref2 = getFloatRef(id_2->getText(),MUST_EXIST);
															r = (*floatref1 != *floatref2) ? 1.0 : 0.0;
														}
														else
														if (mref1) 
														r = (!isMobileEqualN(*mref1, *getFloatRef(id_2->getText(),MUST_EXIST))) ? 1.0 : 0.0;
														else
														r = (!isMobileEqualN(*mref2, *getFloatRef(id_1->getText(),MUST_EXIST))) ? 1.0 : 0.0;
														
#line 2668 "CalcWalker.cpp"
													}
												}
												else {
													bool synPredMatched153 = false;
													if (((_t->getType() == NEQ))) {
														ANTLR_USE_NAMESPACE(antlr)RefAST __t153 = _t;
														synPredMatched153 = true;
														inputState->guessing++;
														try {
															{
															ANTLR_USE_NAMESPACE(antlr)RefAST __t152 = _t;
															ANTLR_USE_NAMESPACE(antlr)RefAST tmp115_AST_in = _t;
															match(_t,NEQ);
															_t = _t->getFirstChild();
															ANTLR_USE_NAMESPACE(antlr)RefAST tmp116_AST_in = _t;
															match(_t,ID);
															_t = _t->getNextSibling();
															ref(_t);
															_t = _retTree;
															_t = __t152;
															_t = _t->getNextSibling();
															}
														}
														catch (ANTLR_USE_NAMESPACE(antlr)RecognitionException& pe) {
															synPredMatched153 = false;
														}
														_t = __t153;
														inputState->guessing--;
													}
													if ( synPredMatched153 ) {
														ANTLR_USE_NAMESPACE(antlr)RefAST __t154 = _t;
														ANTLR_USE_NAMESPACE(antlr)RefAST tmp117_AST_in = _t;
														match(_t,NEQ);
														_t = _t->getFirstChild();
														id5 = _t;
														match(_t,ID);
														_t = _t->getNextSibling();
														mob2=ref(_t);
														_t = _retTree;
														_t = __t154;
														_t = _t->getNextSibling();
														if ( inputState->guessing==0 ) {
#line 885 "calc.g"
															
															mob_adress *mref = getMobileRef(id5->getText());
															if (mref)
															r = (!areMobilesEqual(*mref, mob2)) ? 1.0 : 0.0;
															else {
																double* floatref = getFloatRef(id5->getText(),MUST_EXIST);
																r = (*floatref != conv_ref_to_number(mob2)) ? 1.0 : 0.0;
															}
															
#line 2721 "CalcWalker.cpp"
														}
													}
													else {
														bool synPredMatched157 = false;
														if (((_t->getType() == NEQ))) {
															ANTLR_USE_NAMESPACE(antlr)RefAST __t157 = _t;
															synPredMatched157 = true;
															inputState->guessing++;
															try {
																{
																ANTLR_USE_NAMESPACE(antlr)RefAST __t156 = _t;
																ANTLR_USE_NAMESPACE(antlr)RefAST tmp118_AST_in = _t;
																match(_t,NEQ);
																_t = _t->getFirstChild();
																ref(_t);
																_t = _retTree;
																ANTLR_USE_NAMESPACE(antlr)RefAST tmp119_AST_in = _t;
																match(_t,ID);
																_t = _t->getNextSibling();
																_t = __t156;
																_t = _t->getNextSibling();
																}
															}
															catch (ANTLR_USE_NAMESPACE(antlr)RecognitionException& pe) {
																synPredMatched157 = false;
															}
															_t = __t157;
															inputState->guessing--;
														}
														if ( synPredMatched157 ) {
															ANTLR_USE_NAMESPACE(antlr)RefAST __t158 = _t;
															ANTLR_USE_NAMESPACE(antlr)RefAST tmp120_AST_in = _t;
															match(_t,NEQ);
															_t = _t->getFirstChild();
															mob2=ref(_t);
															_t = _retTree;
															id6 = _t;
															match(_t,ID);
															_t = _t->getNextSibling();
															_t = __t158;
															_t = _t->getNextSibling();
															if ( inputState->guessing==0 ) {
#line 895 "calc.g"
																
																mob_adress *mref = getMobileRef(id6->getText());
																if (mref)
																r = (!areMobilesEqual(*mref, mob2)) ? 1.0 : 0.0;
																else {
																	double* floatref = getFloatRef(id6->getText(),MUST_EXIST);
																	r = (*floatref != conv_ref_to_number(mob2)) ? 1.0 : 0.0;
																}
																
#line 2774 "CalcWalker.cpp"
															}
														}
														else {
															bool synPredMatched161 = false;
															if (((_t->getType() == NEQ))) {
																ANTLR_USE_NAMESPACE(antlr)RefAST __t161 = _t;
																synPredMatched161 = true;
																inputState->guessing++;
																try {
																	{
																	ANTLR_USE_NAMESPACE(antlr)RefAST __t160 = _t;
																	ANTLR_USE_NAMESPACE(antlr)RefAST tmp121_AST_in = _t;
																	match(_t,NEQ);
																	_t = _t->getFirstChild();
																	fexpr(_t);
																	_t = _retTree;
																	fexpr(_t);
																	_t = _retTree;
																	_t = __t160;
																	_t = _t->getNextSibling();
																	}
																}
																catch (ANTLR_USE_NAMESPACE(antlr)RecognitionException& pe) {
																	synPredMatched161 = false;
																}
																_t = __t161;
																inputState->guessing--;
															}
															if ( synPredMatched161 ) {
																ANTLR_USE_NAMESPACE(antlr)RefAST __t162 = _t;
																ANTLR_USE_NAMESPACE(antlr)RefAST tmp122_AST_in = _t;
																match(_t,NEQ);
																_t = _t->getFirstChild();
																a=fexpr(_t);
																_t = _retTree;
																b=fexpr(_t);
																_t = _retTree;
																_t = __t162;
																_t = _t->getNextSibling();
																if ( inputState->guessing==0 ) {
#line 905 "calc.g"
																	if( a != b ) r = 1.0; else r = 0.0;
#line 2817 "CalcWalker.cpp"
																}
															}
															else {
																bool synPredMatched165 = false;
																if (((_t->getType() == NEQ))) {
																	ANTLR_USE_NAMESPACE(antlr)RefAST __t165 = _t;
																	synPredMatched165 = true;
																	inputState->guessing++;
																	try {
																		{
																		ANTLR_USE_NAMESPACE(antlr)RefAST __t164 = _t;
																		ANTLR_USE_NAMESPACE(antlr)RefAST tmp123_AST_in = _t;
																		match(_t,NEQ);
																		_t = _t->getFirstChild();
																		ref(_t);
																		_t = _retTree;
																		ref(_t);
																		_t = _retTree;
																		_t = __t164;
																		_t = _t->getNextSibling();
																		}
																	}
																	catch (ANTLR_USE_NAMESPACE(antlr)RecognitionException& pe) {
																		synPredMatched165 = false;
																	}
																	_t = __t165;
																	inputState->guessing--;
																}
																if ( synPredMatched165 ) {
																	ANTLR_USE_NAMESPACE(antlr)RefAST __t166 = _t;
																	ANTLR_USE_NAMESPACE(antlr)RefAST tmp124_AST_in = _t;
																	match(_t,NEQ);
																	_t = _t->getFirstChild();
																	mob=ref(_t);
																	_t = _retTree;
																	mob2=ref(_t);
																	_t = _retTree;
																	_t = __t166;
																	_t = _t->getNextSibling();
																	if ( inputState->guessing==0 ) {
#line 907 "calc.g"
																		
																			  if (!areMobilesEqual(mob,mob2))  r = 1.0; else r = 0.0;
																		// if( getMobilePtr(mob) != getMobilePtr(mob2) ) r = 1.0; else r = 0.0;
																		
#line 2863 "CalcWalker.cpp"
																	}
																}
		else {
			throw ANTLR_USE_NAMESPACE(antlr)NoViableAltException(_t);
		}
		}}}}}}}}}}}}}}
	}
	catch (ANTLR_USE_NAMESPACE(antlr)RecognitionException& ex) {
		if( inputState->guessing == 0 ) {
			reportError(ex);
			if ( _t != ANTLR_USE_NAMESPACE(antlr)nullAST )
				_t = _t->getNextSibling();
		} else {
			throw;
		}
	}
	_retTree = _t;
	return r;
}

mob_adress  CalcWalker::ref(ANTLR_USE_NAMESPACE(antlr)RefAST _t) {
#line 652 "calc.g"
	mob_adress mob;
#line 2887 "CalcWalker.cpp"
	ANTLR_USE_NAMESPACE(antlr)RefAST ref_AST_in = _t;
	ANTLR_USE_NAMESPACE(antlr)RefAST id = ANTLR_USE_NAMESPACE(antlr)nullAST;
#line 652 "calc.g"
	
	double i,j,dy,ang;
	
#line 2894 "CalcWalker.cpp"
	
	try {      // for error handling
		if (_t == ANTLR_USE_NAMESPACE(antlr)nullAST )
			_t = ASTNULL;
		switch ( _t->getType()) {
		case REF:
		{
			ANTLR_USE_NAMESPACE(antlr)RefAST __t46 = _t;
			ANTLR_USE_NAMESPACE(antlr)RefAST tmp125_AST_in = _t;
			match(_t,REF);
			_t = _t->getFirstChild();
			i=fexpr(_t);
			_t = _retTree;
			j=fexpr(_t);
			_t = _retTree;
			dy=fexpr(_t);
			_t = _retTree;
			ang=fexpr(_t);
			_t = _retTree;
			_t = __t46;
			_t = _t->getNextSibling();
			if ( inputState->guessing==0 ) {
#line 657 "calc.g"
				
				mob.mobile = (int)i;
				mob.client = (int)j;
					    mob.dx = j;
					    mob.dy = dy;
					    mob.angle = ang;
				
#line 2925 "CalcWalker.cpp"
			}
			break;
		}
		case ID:
		{
			id = _t;
			match(_t,ID);
			_t = _t->getNextSibling();
			if ( inputState->guessing==0 ) {
#line 665 "calc.g"
				
					  // cerr << "[DEBUG] ID=ref\n";
				mob_adress *mref = getMobileRef(id->getText());
				if( mref )
				mob = *mref;
				else
					    {
					        double *floatref = getFloatRef(id->getText(), MUST_EXIST);
						if( floatref != NULL )
						{
						  mob.mobile = ((int)(*floatref)); // cast (ref)fexp
						  mob.client = -1;
						}
					else
					{
						  mob.mobile = -100;
						  mob.client = -100;
					}
					    }
				
#line 2956 "CalcWalker.cpp"
			}
			break;
		}
		default:
		{
			throw ANTLR_USE_NAMESPACE(antlr)NoViableAltException(_t);
		}
		}
	}
	catch (ANTLR_USE_NAMESPACE(antlr)RecognitionException& ex) {
		if( inputState->guessing == 0 ) {
			reportError(ex);
			if ( _t != ANTLR_USE_NAMESPACE(antlr)nullAST )
				_t = _t->getNextSibling();
		} else {
			throw;
		}
	}
	_retTree = _t;
	return mob;
}

atr_nfo  CalcWalker::attribref(ANTLR_USE_NAMESPACE(antlr)RefAST _t) {
#line 688 "calc.g"
	atr_nfo nfo;
#line 2982 "CalcWalker.cpp"
	ANTLR_USE_NAMESPACE(antlr)RefAST attribref_AST_in = _t;
	ANTLR_USE_NAMESPACE(antlr)RefAST i = ANTLR_USE_NAMESPACE(antlr)nullAST;
#line 688 "calc.g"
	
	mob_adress mob;
	
#line 2989 "CalcWalker.cpp"
	
	try {      // for error handling
		if (_t == ANTLR_USE_NAMESPACE(antlr)nullAST )
			_t = ASTNULL;
		switch ( _t->getType()) {
		case LITERAL_x:
		{
			ANTLR_USE_NAMESPACE(antlr)RefAST __t48 = _t;
			ANTLR_USE_NAMESPACE(antlr)RefAST tmp126_AST_in = _t;
			match(_t,LITERAL_x);
			_t = _t->getFirstChild();
			mob=ref(_t);
			_t = _retTree;
			_t = __t48;
			_t = _t->getNextSibling();
			if ( inputState->guessing==0 ) {
#line 692 "calc.g"
				set_atr_nfo(nfo, mob.mobile, mob.client, "x",  0);
#line 3008 "CalcWalker.cpp"
			}
			break;
		}
		case LITERAL_y:
		{
			ANTLR_USE_NAMESPACE(antlr)RefAST __t49 = _t;
			ANTLR_USE_NAMESPACE(antlr)RefAST tmp127_AST_in = _t;
			match(_t,LITERAL_y);
			_t = _t->getFirstChild();
			mob=ref(_t);
			_t = _retTree;
			_t = __t49;
			_t = _t->getNextSibling();
			if ( inputState->guessing==0 ) {
#line 693 "calc.g"
				set_atr_nfo(nfo, mob.mobile, mob.client, "y",  0);
#line 3025 "CalcWalker.cpp"
			}
			break;
		}
		case LITERAL_dx:
		{
			ANTLR_USE_NAMESPACE(antlr)RefAST __t50 = _t;
			ANTLR_USE_NAMESPACE(antlr)RefAST tmp128_AST_in = _t;
			match(_t,LITERAL_dx);
			_t = _t->getFirstChild();
			mob=ref(_t);
			_t = _retTree;
			_t = __t50;
			_t = _t->getNextSibling();
			if ( inputState->guessing==0 ) {
#line 694 "calc.g"
				set_atr_nfo(nfo, mob.mobile, mob.client, "dx", 0);
#line 3042 "CalcWalker.cpp"
			}
			break;
		}
		case LITERAL_dy:
		{
			ANTLR_USE_NAMESPACE(antlr)RefAST __t51 = _t;
			ANTLR_USE_NAMESPACE(antlr)RefAST tmp129_AST_in = _t;
			match(_t,LITERAL_dy);
			_t = _t->getFirstChild();
			mob=ref(_t);
			_t = _retTree;
			_t = __t51;
			_t = _t->getNextSibling();
			if ( inputState->guessing==0 ) {
#line 695 "calc.g"
				set_atr_nfo(nfo, mob.mobile, mob.client, "dy", 0);
#line 3059 "CalcWalker.cpp"
			}
			break;
		}
		case LITERAL_angle:
		{
			ANTLR_USE_NAMESPACE(antlr)RefAST __t52 = _t;
			ANTLR_USE_NAMESPACE(antlr)RefAST tmp130_AST_in = _t;
			match(_t,LITERAL_angle);
			_t = _t->getFirstChild();
			mob=ref(_t);
			_t = _retTree;
			_t = __t52;
			_t = _t->getNextSibling();
			if ( inputState->guessing==0 ) {
#line 696 "calc.g"
				set_atr_nfo(nfo, mob.mobile, mob.client, "angle", 0);
#line 3076 "CalcWalker.cpp"
			}
			break;
		}
		case LITERAL_icon:
		{
			ANTLR_USE_NAMESPACE(antlr)RefAST __t53 = _t;
			ANTLR_USE_NAMESPACE(antlr)RefAST tmp131_AST_in = _t;
			match(_t,LITERAL_icon);
			_t = _t->getFirstChild();
			mob=ref(_t);
			_t = _retTree;
			_t = __t53;
			_t = _t->getNextSibling();
			if ( inputState->guessing==0 ) {
#line 697 "calc.g"
				set_atr_nfo(nfo, mob.mobile, mob.client, "icon", 0);
#line 3093 "CalcWalker.cpp"
			}
			break;
		}
		case LITERAL_color:
		{
			ANTLR_USE_NAMESPACE(antlr)RefAST __t54 = _t;
			ANTLR_USE_NAMESPACE(antlr)RefAST tmp132_AST_in = _t;
			match(_t,LITERAL_color);
			_t = _t->getFirstChild();
			mob=ref(_t);
			_t = _retTree;
			_t = __t54;
			_t = _t->getNextSibling();
			if ( inputState->guessing==0 ) {
#line 698 "calc.g"
				set_atr_nfo(nfo, mob.mobile, mob.client, "color", 0);
#line 3110 "CalcWalker.cpp"
			}
			break;
		}
		case LITERAL_red:
		{
			ANTLR_USE_NAMESPACE(antlr)RefAST __t55 = _t;
			ANTLR_USE_NAMESPACE(antlr)RefAST tmp133_AST_in = _t;
			match(_t,LITERAL_red);
			_t = _t->getFirstChild();
			mob=ref(_t);
			_t = _retTree;
			_t = __t55;
			_t = _t->getNextSibling();
			if ( inputState->guessing==0 ) {
#line 699 "calc.g"
				set_atr_nfo(nfo, mob.mobile, mob.client, "red", 0);
#line 3127 "CalcWalker.cpp"
			}
			break;
		}
		case LITERAL_green:
		{
			ANTLR_USE_NAMESPACE(antlr)RefAST __t56 = _t;
			ANTLR_USE_NAMESPACE(antlr)RefAST tmp134_AST_in = _t;
			match(_t,LITERAL_green);
			_t = _t->getFirstChild();
			mob=ref(_t);
			_t = _retTree;
			_t = __t56;
			_t = _t->getNextSibling();
			if ( inputState->guessing==0 ) {
#line 700 "calc.g"
				set_atr_nfo(nfo, mob.mobile, mob.client, "green", 0);
#line 3144 "CalcWalker.cpp"
			}
			break;
		}
		case LITERAL_blue:
		{
			ANTLR_USE_NAMESPACE(antlr)RefAST __t57 = _t;
			ANTLR_USE_NAMESPACE(antlr)RefAST tmp135_AST_in = _t;
			match(_t,LITERAL_blue);
			_t = _t->getFirstChild();
			mob=ref(_t);
			_t = _retTree;
			_t = __t57;
			_t = _t->getNextSibling();
			if ( inputState->guessing==0 ) {
#line 701 "calc.g"
				set_atr_nfo(nfo, mob.mobile, mob.client, "blue", 0);
#line 3161 "CalcWalker.cpp"
			}
			break;
		}
		case LITERAL_gray:
		{
			ANTLR_USE_NAMESPACE(antlr)RefAST __t58 = _t;
			ANTLR_USE_NAMESPACE(antlr)RefAST tmp136_AST_in = _t;
			match(_t,LITERAL_gray);
			_t = _t->getFirstChild();
			mob=ref(_t);
			_t = _retTree;
			_t = __t58;
			_t = _t->getNextSibling();
			if ( inputState->guessing==0 ) {
#line 702 "calc.g"
				set_atr_nfo(nfo, mob.mobile, mob.client, "gray", 0);
#line 3178 "CalcWalker.cpp"
			}
			break;
		}
		case LITERAL_shockx:
		{
			ANTLR_USE_NAMESPACE(antlr)RefAST __t59 = _t;
			ANTLR_USE_NAMESPACE(antlr)RefAST tmp137_AST_in = _t;
			match(_t,LITERAL_shockx);
			_t = _t->getFirstChild();
			mob=ref(_t);
			_t = _retTree;
			_t = __t59;
			_t = _t->getNextSibling();
			if ( inputState->guessing==0 ) {
#line 703 "calc.g"
				set_atr_nfo(nfo, mob.mobile, mob.client, "shockx", 0);
#line 3195 "CalcWalker.cpp"
			}
			break;
		}
		case LITERAL_shocky:
		{
			ANTLR_USE_NAMESPACE(antlr)RefAST __t60 = _t;
			ANTLR_USE_NAMESPACE(antlr)RefAST tmp138_AST_in = _t;
			match(_t,LITERAL_shocky);
			_t = _t->getFirstChild();
			mob=ref(_t);
			_t = _retTree;
			_t = __t60;
			_t = _t->getNextSibling();
			if ( inputState->guessing==0 ) {
#line 704 "calc.g"
				set_atr_nfo(nfo, mob.mobile, mob.client, "shocky", 0);
#line 3212 "CalcWalker.cpp"
			}
			break;
		}
		case LITERAL_width:
		{
			ANTLR_USE_NAMESPACE(antlr)RefAST __t61 = _t;
			ANTLR_USE_NAMESPACE(antlr)RefAST tmp139_AST_in = _t;
			match(_t,LITERAL_width);
			_t = _t->getFirstChild();
			mob=ref(_t);
			_t = _retTree;
			_t = __t61;
			_t = _t->getNextSibling();
			if ( inputState->guessing==0 ) {
#line 705 "calc.g"
				set_atr_nfo(nfo, mob.mobile, mob.client, "width", 0);
#line 3229 "CalcWalker.cpp"
			}
			break;
		}
		case LITERAL_height:
		{
			ANTLR_USE_NAMESPACE(antlr)RefAST __t62 = _t;
			ANTLR_USE_NAMESPACE(antlr)RefAST tmp140_AST_in = _t;
			match(_t,LITERAL_height);
			_t = _t->getFirstChild();
			mob=ref(_t);
			_t = _retTree;
			_t = __t62;
			_t = _t->getNextSibling();
			if ( inputState->guessing==0 ) {
#line 706 "calc.g"
				set_atr_nfo(nfo, mob.mobile, mob.client, "height", 0);
#line 3246 "CalcWalker.cpp"
			}
			break;
		}
		case LITERAL_zoom:
		{
			ANTLR_USE_NAMESPACE(antlr)RefAST __t63 = _t;
			ANTLR_USE_NAMESPACE(antlr)RefAST tmp141_AST_in = _t;
			match(_t,LITERAL_zoom);
			_t = _t->getFirstChild();
			mob=ref(_t);
			_t = _retTree;
			_t = __t63;
			_t = _t->getNextSibling();
			if ( inputState->guessing==0 ) {
#line 707 "calc.g"
				set_atr_nfo(nfo, mob.mobile, mob.client, "zoom", 0);
#line 3263 "CalcWalker.cpp"
			}
			break;
		}
		case LITERAL_visible:
		{
			ANTLR_USE_NAMESPACE(antlr)RefAST __t64 = _t;
			ANTLR_USE_NAMESPACE(antlr)RefAST tmp142_AST_in = _t;
			match(_t,LITERAL_visible);
			_t = _t->getFirstChild();
			mob=ref(_t);
			_t = _retTree;
			_t = __t64;
			_t = _t->getNextSibling();
			if ( inputState->guessing==0 ) {
#line 708 "calc.g"
				set_atr_nfo(nfo, mob.mobile, mob.client, "visible", 0);
#line 3280 "CalcWalker.cpp"
			}
			break;
		}
		case LITERAL_contact:
		{
			ANTLR_USE_NAMESPACE(antlr)RefAST __t65 = _t;
			ANTLR_USE_NAMESPACE(antlr)RefAST tmp143_AST_in = _t;
			match(_t,LITERAL_contact);
			_t = _t->getFirstChild();
			mob=ref(_t);
			_t = _retTree;
			_t = __t65;
			_t = _t->getNextSibling();
			if ( inputState->guessing==0 ) {
#line 709 "calc.g"
				set_atr_nfo(nfo, mob.mobile, mob.client, "contact", 0);
#line 3297 "CalcWalker.cpp"
			}
			break;
		}
		case LITERAL_mem:
		{
			ANTLR_USE_NAMESPACE(antlr)RefAST __t66 = _t;
			i = (_t == ASTNULL) ? ANTLR_USE_NAMESPACE(antlr)nullAST : _t;
			match(_t,LITERAL_mem);
			_t = _t->getFirstChild();
			mob=ref(_t);
			_t = _retTree;
			_t = __t66;
			_t = _t->getNextSibling();
			if ( inputState->guessing==0 ) {
#line 710 "calc.g"
				set_atr_nfo(nfo, mob.mobile, mob.client, "mem", atof(i->getText().c_str()));
#line 3314 "CalcWalker.cpp"
			}
			break;
		}
		default:
		{
			throw ANTLR_USE_NAMESPACE(antlr)NoViableAltException(_t);
		}
		}
	}
	catch (ANTLR_USE_NAMESPACE(antlr)RecognitionException& ex) {
		if( inputState->guessing == 0 ) {
			reportError(ex);
			if ( _t != ANTLR_USE_NAMESPACE(antlr)nullAST )
				_t = _t->getNextSibling();
		} else {
			throw;
		}
	}
	_retTree = _t;
	return nfo;
}

void CalcWalker::initializeASTFactory( ANTLR_USE_NAMESPACE(antlr)ASTFactory& )
{
}
const char* CalcWalker::tokenNames[] = {
	"<0>",
	"EOF",
	"<2>",
	"NULL_TREE_LOOKAHEAD",
	"\"if\"",
	"\"stop\"",
	"\"start\"",
	"\"restart\"",
	"\"like\"",
	"\"move_to\"",
	"\"echo\"",
	"un mot",
	"':'",
	"\"trace\"",
	"REF",
	"\"x\"",
	"\"y\"",
	"\"dx\"",
	"\"dy\"",
	"\"angle\"",
	"\"icon\"",
	"\"color\"",
	"\"red\"",
	"\"green\"",
	"\"blue\"",
	"\"gray\"",
	"\"shockx\"",
	"\"shocky\"",
	"\"width\"",
	"\"height\"",
	"\"zoom\"",
	"\"visible\"",
	"\"contact\"",
	"\"mem\"",
	"'+'",
	"'-'",
	"'*'",
	"'/'",
	"FLOAT",
	"un nombre",
	"\"sqr\"",
	"\"sqrt\"",
	"\"abs\"",
	"\"sin\"",
	"\"cos\"",
	"\"tan\"",
	"\"acs\"",
	"\"asn\"",
	"\"exp\"",
	"\"log\"",
	"\"clic\"",
	"\"click\"",
	"\"unclick\"",
	"\"clicked\"",
	"\"key_left\"",
	"\"key_right\"",
	"\"key_up\"",
	"\"key_down\"",
	"\"key_space\"",
	"\"rnd\"",
	"\"srnd\"",
	"\"ang\"",
	"\"min\"",
	"\"max\"",
	"\"int\"",
	"\"frac\"",
	"\"sgn\"",
	"\"norm\"",
	"\"mod\"",
	"\"dist\"",
	"\"t\"",
	"\"dt\"",
	"'='",
	"'<>'",
	"'>'",
	"'>='",
	"'<'",
	"'<='",
	"\"and\"",
	"\"or\"",
	"fin de la ligne",
	"';'",
	"\"then\"",
	"\"else\"",
	"\"endif\"",
	"'('",
	"','",
	"')'",
	"\"me\"",
	"\"prev\"",
	"\"next\"",
	"\"EMPTY\"",
	"\"camera\"",
	"\"light_one\"",
	"\"light_two\"",
	"\"light_three\"",
	"'@'",
	"\"mouse\"",
	"\"collider\"",
	"\"nearest\"",
	"\"nearest_second\"",
	"\"nearest_third\"",
	"\"nearest_left\"",
	"\"nearest_right\"",
	"\"nearest_up\"",
	"\"nearest_down\"",
	"\"nearest_in_dir\"",
	"\"nearest_in_dir_second\"",
	"\"nearest_in_dir_third\"",
	"\"PI\"",
	"\"pi\"",
	"\"Pi\"",
	"\"RED\"",
	"\"GREEN\"",
	"\"BLUE\"",
	"\"YELLOW\"",
	"\"CYAN\"",
	"\"PURPLE\"",
	"\"WHITE\"",
	"\"BLACK\"",
	"\"GRAY\"",
	"\"ORANGE\"",
	"un commentaire",
	"des chiffres",
	"des lettres",
	"un attribut",
	"SYNONYMS",
	"FRENCH_VOCAB",
	"WS_",
	0
};

const unsigned long CalcWalker::_tokenSet_0_data_[] = { 6128UL, 0UL, 0UL, 0UL, 0UL, 0UL };
// "if" "stop" "start" "restart" "like" "move_to" "echo" COLON 
const ANTLR_USE_NAMESPACE(antlr)BitSet CalcWalker::_tokenSet_0(_tokenSet_0_data_,6);


