// ----------------------------------------------------
/*
   class UDistance

   Author :   Sylvain Lefebvre
   Created:   19/11/2002

 */
// ----------------------------------------------------
#include <map>
#include "CVertex.h"
// ----------------------------------------------------
namespace UDistance
{
  typedef std::pair<double,CVertex> hit;
  typedef CVertex point;

  struct segment
  {
    point  p0;
    point  p1;
    point  d;
    double t;
    segment(point _p0,point _p1);
  };

  struct line
  {
    point p;
    point d;
    line(point _p,point _d);
    line (const segment& s);
  };

  const hit& _min(const hit& h0,const hit& h1);

  hit dist2dsqr(const point& p0,const point& p1);
  hit dist2dsqr(const point& p,const line& l);
  hit dist2dsqr(const point& p,const segment& s);
  hit dist2dsqr(const segment& s0,const segment& s1);
};
// ----------------------------------------------------
